package phi;

import javax.swing.JOptionPane;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */

/*
 suelements

      - EncrryptionMethod -> minOccur = 0
      - KeyInfo -> minOccur = 0
      - CipherData
      - EncryptoinProperties -> minOccur = 0
      - ReferenceList -> minOccur = 0
      - CarriedName -> minOccur = 0

 attributes (all optional)
      - Id
      - Type
      - MimeType
      - Encoding
      - Recipient
 */
public class EncryptedKey {
    public EncryptedKey() {
    }


    /***********************************************
   * phi of EncryptedKey with one arguement
   ************************************************/
  public static String eval(phiData phData, org.w3c.dom.Node evalNode) {
        String szResult="",szEncryptedKey="", szCipherResult="", szEncrypting="", szKeyName=null;
        psiData psiEncryptedKey;

        org.w3c.dom.Node indexNode,ReferenceListNode=null,KeyInfoNode=null, EncryptionMethodNode=null;
        org.w3c.dom.NodeList list;

    if (!phData.bAbstracted) {
        psiEncryptedKey = phiClass.retPsiData(phData, evalNode, "EncryptedKey","Please specify the key encrypted in the CipherData in the marked of EncryptedKey element.", true, null);

        szEncryptedKey = psiEncryptedKey.getPsiDataValue();
        //Check if a key supplied and if not return
        if (szEncryptedKey.equals(""))
            return ("");
    }

    list = evalNode.getChildNodes();

    // Loop through the list.
    for (int i=0; i < list.getLength(); i++) {
        indexNode = list.item(i);
        if (indexNode.getNodeType() == indexNode.ELEMENT_NODE) {
            if (indexNode.getLocalName().equals("ReferenceList")) {
                ReferenceListNode = indexNode;
            } else if (indexNode.getLocalName().equals("KeyInfo")) {
                KeyInfoNode = indexNode;
            } else if (indexNode.getLocalName().equals("CarriedKeyName")) {
                szKeyName = indexNode.getNodeValue().trim();
            } else if (indexNode.getLocalName().equals("EncryptionMethod")) {
                EncryptionMethodNode = indexNode;
            } else if (indexNode.getLocalName().equals("CipherData")) {
                if (phData.bAbstracted) {
                    szCipherResult = phiClass.evaluateNode(phData, indexNode);
                    szCipherResult = szCipherResult.trim();
                    int indexOfFirstClose = szCipherResult.indexOf('}');
                    if (szCipherResult.charAt(0) == '{' &&
                        indexOfFirstClose > 1 &&
                        szCipherResult.lastIndexOf('{') ==
                        indexOfFirstClose + 1 &&
                        szCipherResult.lastIndexOf('}') ==
                        szCipherResult.length() - 1) {

                        szEncryptedKey = szCipherResult.substring(1,indexOfFirstClose);
                        phiClass.saveAbstractedPsiData(phData, evalNode, szEncryptedKey, "EncryptedKey",true);


                    } else {
                        JOptionPane.showMessageDialog(null,
                                "EncryptedKey: CipherData contains invalid text", "Abort",
                                JOptionPane.ERROR_MESSAGE);
                        phData.phiAborted = true;
                        return ("");
                    }
                }
            }
        }
    }

    if (szKeyName != null)
        phData.phiSaveKeyName(szKeyName,szEncryptedKey, true);


    if (KeyInfoNode != null){

        szEncrypting = phiClass.evaluateNode(phData, KeyInfoNode, "ENC");

        if ( szEncrypting.matches("") )
           return("");
        else
           phiClass.saveAbstractedPsiData(phData, evalNode, szEncrypting, "Encrypting", phData.phiIsSymmetric(szEncrypting));

        //Check if the abstracted values in the SOAP message are consistent
        if (phData.bAbstracted) {
            if (!szCipherResult.equals("{" + szEncryptedKey + "}{"+ szEncrypting +"}")) {
                //inconsistency was discovered
                JOptionPane.showMessageDialog(null,"EncryptedKey: Inconsistency between CipherData and KeyInfo in EncryptedKey element" ,"Abort" , JOptionPane.ERROR_MESSAGE);
                phData.phiAborted = true;
                return("");
            }
        }

        szResult = phiClass.evaluateNode(phData, KeyInfoNode) + ", ";

        if ( szResult.trim().equals(",") )
            szResult = "";

    } else if (!((szEncrypting = checkKeyReference(phData, evalNode)).equals(""))) {

       phiClass.saveAbstractedPsiData(phData, evalNode, szEncrypting, "Encrypting", phData.phiIsSymmetric(szEncrypting));

       //Check if the abstracted values in the SOAP message are consistent
       if (phData.bAbstracted) {
           if (!szCipherResult.equals("{" + szEncryptedKey + "}{"+ szEncrypting +"}")) {
              //inconsistency was discovered
              JOptionPane.showMessageDialog(null,"EncryptedKey: Inconsistency between CipherData and KeyInfo in EncryptedKey element" ,"Abort" , JOptionPane.ERROR_MESSAGE);
              phData.phiAborted = true;
              return("");
           }
       }

    } else if (!phData.bAbstracted) {

        szEncrypting = checkKeyInfo(phData, evalNode, EncryptionMethodNode);

        if (szEncrypting.equals(""))
            return("");

    } else {
        //If nether KeyInfo nor KeyReference exists

        //Check first if EncryptionMethod elemnt exists and indicate if the encrypting
        //key symmetric or not
        String szIsSmetric = evalEncryptionMethod(phData, EncryptionMethodNode);

        szEncrypting = szCipherResult.substring(szCipherResult.lastIndexOf('{') + 1, szCipherResult.lastIndexOf('}'));
        if ( (szEncrypting.startsWith("PK(") || szEncrypting.startsWith("SK(")) && szEncrypting.length() > 4 && szEncrypting.endsWith(")") ) {
            if ( szIsSmetric.equalsIgnoreCase("Yes") ){
                JOptionPane.showMessageDialog(null,"EncryptedKey: Inconsistency between the EncryptionMethod and in encrypting key in CipherData" ,"Abort" , JOptionPane.ERROR_MESSAGE);
                phData.phiAborted = true;
                return("");
            }
            phiClass.saveAbstractedPsiData(phData, evalNode, szEncrypting, "Encrypting", false);
        }
        else {
            if ( szIsSmetric.equalsIgnoreCase("No") ){
                JOptionPane.showMessageDialog(null,"EncryptedKey: Inconsistency between the EncryptionMethod and in encrypting key in CipherData" ,"Abort" , JOptionPane.ERROR_MESSAGE);
                phData.phiAborted = true;
                return("");
            }
            phiClass.saveAbstractedPsiData(phData, evalNode, szEncrypting, "Encrypting", true);
        }
    }

    if (ReferenceListNode != null)
          phiClass.evaluateNode(phData, ReferenceListNode, szEncryptedKey);


    szResult = szResult.concat("{" + szEncryptedKey + "}{" + szEncrypting +"}");



    return(szResult);
  }






  /***********************************************
   * phi of EncryptedKey with two arguements
   ************************************************/

  public static String eval(phiData phData, org.w3c.dom.Node evalNode, String szArg) {
     String szResult="",szEncryptedKey="", szCipherResult="", szEncrypting="", szKeyName=null;
     psiData psiEncryptedKey;

     org.w3c.dom.Node indexNode,ReferenceListNode=null,KeyInfoNode=null, EncryptionMethodNode=null;
     org.w3c.dom.NodeList list;


     if (!phData.bAbstracted) {
        psiEncryptedKey = phiClass.retPsiData(phData, evalNode, "EncryptedKey","Please specify the key encrypted in the CipherData in the marked of EncryptedKey element.", true, null);

        szEncryptedKey = psiEncryptedKey.getPsiDataValue();
        //Check if a key supplied and if not return
        if (szEncryptedKey.equals(""))
           return ("");
     }

     list = evalNode.getChildNodes();

     // Loop through the list.
     for (int i=0; i < list.getLength(); i++) {
        indexNode = list.item(i);
        if (indexNode.getNodeType() == indexNode.ELEMENT_NODE) {
           if (indexNode.getLocalName().equals("ReferenceList")) {
              ReferenceListNode = indexNode;
           } else if (indexNode.getLocalName().equals("KeyInfo")) {
              KeyInfoNode = indexNode;
           } else if (indexNode.getLocalName().equals("CarriedKeyName")) {
              szKeyName = indexNode.getNodeValue().trim();
          } else if (indexNode.getLocalName().equals("EncryptionMethod")) {
               EncryptionMethodNode = indexNode;
           } else if (indexNode.getLocalName().equals("CipherData")) {
              if (phData.bAbstracted) {
                 szCipherResult = phiClass.evaluateNode(phData, indexNode);
                 szCipherResult = szCipherResult.trim();
                 int indexOfFirstClose = szCipherResult.indexOf('}');
                 if (szCipherResult.charAt(0) == '{' &&
                    indexOfFirstClose > 1 &&
                    szCipherResult.lastIndexOf('{') ==
                    indexOfFirstClose + 1 &&
                    szCipherResult.lastIndexOf('}') ==
                    szCipherResult.length() - 1) {

                    szEncryptedKey = szCipherResult.substring(1,indexOfFirstClose);
                    phiClass.saveAbstractedPsiData(phData, evalNode, szEncryptedKey, "EncryptedKey",true);


                 } else {
                    JOptionPane.showMessageDialog(null,
                            "EncryptedKey: CipherData contains invalid text", "Abort",
                            JOptionPane.ERROR_MESSAGE);
                    phData.phiAborted = true;
                    return ("");
                 }
               }
           }
       }
   }

   //if the second argument is not "SIGNATURE" then return the encryptedKey
   if (!szArg.equals("SIGNATURE")) {
       return(szEncryptedKey);
   }


   if (szKeyName != null)
      phData.phiSaveKeyName(szKeyName,szEncryptedKey, true);


   if (KeyInfoNode != null){

      szEncrypting = phiClass.evaluateNode(phData, KeyInfoNode, "SIGNATURE");

      if ( szEncrypting.matches("") )
           return("");
        else
           phiClass.saveAbstractedPsiData(phData, evalNode, szEncrypting, "Encrypting", phData.phiIsSymmetric(szEncrypting));


      //Check if the abstracted values in the SOAP message are consistent
      if (phData.bAbstracted) {
         if (!szCipherResult.equals("{" + szEncryptedKey + "}{"+ szEncrypting +"}")) {
            //inconsistency was discovered
            JOptionPane.showMessageDialog(null,"EncryptedKey: Inconsistency between CipherData and KeyInfo in EncryptedKey element" ,"Abort" , JOptionPane.ERROR_MESSAGE);
            phData.phiAborted = true;
            return("");
         }
      }

      szResult = phiClass.evaluateNode(phData, KeyInfoNode) + ",";

      if ( szResult.trim().equals(",") )
            szResult = "";


   } else if (!((szEncrypting = checkKeyReference(phData, evalNode)).equals(""))) {

      phiClass.saveAbstractedPsiData(phData, evalNode, szEncrypting, "Encrypting", phData.phiIsSymmetric(szEncrypting));

      //Check if the abstracted values in the SOAP message are consistent
      if (phData.bAbstracted) {
         if (!szCipherResult.equals("{" + szEncryptedKey + "}{"+ szEncrypting +"}")) {
            //inconsistency was discovered
            JOptionPane.showMessageDialog(null,"EncryptedKey: Inconsistency between CipherData and KeyInfo in EncryptedKey element" ,"Abort" , JOptionPane.ERROR_MESSAGE);
            phData.phiAborted = true;
            return("");
         }
      }

   } else if (!phData.bAbstracted) {

       szEncrypting = checkKeyInfo(phData, evalNode, EncryptionMethodNode);

       if (szEncrypting.equals(""))
          return("");

   } else {
           //If nether KeyInfo nor KeyReference exists

           //Check first if EncryptionMethod elemnt exists and indicate if the encrypting
           //key symmetric or not
           String szIsSmetric = evalEncryptionMethod(phData, EncryptionMethodNode);

           szEncrypting = szCipherResult.substring(szCipherResult.lastIndexOf('{') + 1, szCipherResult.lastIndexOf('}'));
           if ( szEncrypting.startsWith("PK(") && szEncrypting.length() > 4 && szEncrypting.endsWith(")") ) {
               if ( szIsSmetric.equalsIgnoreCase("Yes") ){
                   JOptionPane.showMessageDialog(null,"EncryptedKey: Inconsistency between the EncryptionMethod and in encrypting key in CipherData" ,"Abort" , JOptionPane.ERROR_MESSAGE);
                   phData.phiAborted = true;
                   return("");
               }
               phiClass.saveAbstractedPsiData(phData, evalNode, szEncrypting, "Encrypting", false);
           } else if ( szEncrypting.startsWith("SK(") && szEncrypting.length() > 4 && szEncrypting.endsWith(")") ) {
               JOptionPane.showMessageDialog(null,"EncryptedKey: The key should not be signed but encrypted using a public key" ,"Abort" , JOptionPane.ERROR_MESSAGE);
                    phData.phiAborted = true;
                    return("");
           }else {
               if ( szIsSmetric.equalsIgnoreCase("No") ){
                   JOptionPane.showMessageDialog(null,"EncryptedKey: Inconsistency between the EncryptionMethod and in encrypting key in CipherData" ,"Abort" , JOptionPane.ERROR_MESSAGE);
                   phData.phiAborted = true;
                   return("");
               }
               phiClass.saveAbstractedPsiData(phData, evalNode, szEncrypting, "Encrypting", true);
           }
       }


       if (ReferenceListNode != null)
           szResult = szResult.concat(phiClass.evaluateNode(phData, ReferenceListNode, "SIGNATURE") + ", " +
                                      "{" + szEncryptedKey + "}{" + szEncrypting +"}");
       else
           szResult = szResult.concat("{" + szEncryptedKey + "}{" + szEncrypting +"}");



       return(szResult);
   }






    //This EncryptedKey element does not have a KeyInfo Child
    //Look for another EncryptedKey which points to this one
    //via a KeyReference elemnt
    //Note: KeyReference can only point to EncryptedKey
    private static String checkKeyReference(phiData phData, org.w3c.dom.Node evalNode) {
        org.w3c.dom.Node indexNode, attrNode, tempAttrNode;
        org.w3c.dom.NodeList list, list2;

        attrNode = evalNode.getAttributes().getNamedItemNS(phData.utilitySchemaURI,"Id");

        if (attrNode == null)
            attrNode = evalNode.getAttributes().getNamedItem("Id");

        if (attrNode != null) {

            //Check the context
            context nodeContext;

            //Check if this node was already proccessed
            nodeContext = phData.phiRetContext(attrNode.getNodeValue());

            if (!nodeContext.isContextEmpty())
               return (nodeContext.getContextValue());

            //Look for an approperiate KeyReference element in the document
            list = phData.document.getElementsByTagName("KeyReference");
            list2 = phData.document.getElementsByTagNameNS(phData.xmlEncURI,"KeyReference");

            for (int i = 0; i < (list.getLength() + list2.getLength()); i++) {
                if (i < list.getLength() )
                    indexNode = list.item(i);
                else
                    indexNode = list2.item(i - list.getLength());

                tempAttrNode = indexNode.getAttributes().getNamedItem("URI");

                if (tempAttrNode == null)
                    tempAttrNode = indexNode.getAttributes().getNamedItemNS(phData.xmlEncURI, "URI");

                if (tempAttrNode != null) {
                    if (tempAttrNode.getNodeValue().equals("#" + attrNode.getNodeValue()))
                        if (indexNode.getParentNode().getParentNode().getLocalName().equals("EncryptedKey"))
                            return(phiClass.evaluateNode(phData,indexNode.getParentNode().getParentNode(),"ENC"));
                }
            }

        }

      return("");
    }



    //This EncryptedKey element has neither a KeyInfo element nor
    //another EncryptedKey pointing at it. Ask the user for the encrypting
    //Key (In the case of Abstracted Message we already know it from the Cipher
    //Data element, so there is no need to ask
    private static String checkKeyInfo(phiData phData,
                                      org.w3c.dom.Node evalNode,
                                      org.w3c.dom.Node EncryptionMethodNode) {
        String szEncrypting="", szIsSmetric;
        String[] options = {"Yes", "No"};
        psiData psiEncryptedKey, psiIsSymetric;

        szIsSmetric = evalEncryptionMethod(phData, EncryptionMethodNode);

        if ( szIsSmetric.equals("") ) {
            psiIsSymetric = phiClass.retPsiData(
                    phData,
                    evalNode,
                    "Symetric",
                    "The encrypting key of the marked EncryptedKey seems to be agreed applicatively. Is it Symetric key (yes/no)",
                    false,
                    options);

            //Check if an answer supplied and if not return
            if (psiIsSymetric.getPsiDataValue().equals(""))
                return ("");
            else
                szIsSmetric = psiIsSymetric.getPsiDataValue();
        }

        if (szIsSmetric.equalsIgnoreCase("Yes"))
            psiEncryptedKey = phiClass.retPsiData(phData, evalNode, "Encrypting", "The encrypting key of the marked EncryptedKey seems to be agreed applicatively. Please specify the symetric encripting key of the marked of EncryptedKey element.", true, null);
        else
            psiEncryptedKey = phiClass.retPsiData(phData, evalNode, "Encrypting", "The encrypting key of the marked EncryptedKey seems to be agreed applicatively. Please specify the public key owner", false, null);

        szEncrypting = psiEncryptedKey.getPsiDataValue();

        //Check if a key supplied and if not return
        if (szEncrypting.equals(""))
            return ("");

        if (szIsSmetric.equalsIgnoreCase("No"))
            szEncrypting = "PK(" + szEncrypting + ")";

        return(szEncrypting);
    }


    //Reading the EncryptionMethod element to find out if the encrypting key is symetric or not
    //
    // Returns: yes if symetric key algorithm
    // Returns: no if asymetric key algorithm
    // Returns: "" if no recognized algorithm
    public static String evalEncryptionMethod(phiData phData, org.w3c.dom.Node EncryptionMethodNode){

        org.w3c.dom.Node AlogorithmNode;
        String szAlgorithmURI, szAlgorithmName;

        if (EncryptionMethodNode == null)
            return("");
        else {
            AlogorithmNode = EncryptionMethodNode.getAttributes().getNamedItem("Algorithm");

            if (AlogorithmNode == null)
                AlogorithmNode = EncryptionMethodNode.getAttributes().getNamedItemNS(phData.xmlEncURI, "Algorithm");

            szAlgorithmURI = AlogorithmNode.getNodeValue();

            int namePosition = szAlgorithmURI.indexOf("xmlenc#") + 7;

            szAlgorithmName = szAlgorithmURI.substring(namePosition);

            //Block Encryption
            if (szAlgorithmName.startsWith("tripledes") || szAlgorithmName.startsWith("aes") ){
                return("Yes");
            }
            //Key Transport
            else if (szAlgorithmName.startsWith("rsa") ){
                return("No");
            }
            //Symmetric Key Wrap
            else if (szAlgorithmName.startsWith("kw") ){
                return("Yes");
            }


        }

        return("");
    }

}
