package phi;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
/*
 attributes (all optional)
      - URI
      - ValueType
 */
public class Reference {
    public Reference() {
    }

    /***********************************************
     * phi of Reference with one arguement
     ************************************************/
     public static String eval(phiData phData, org.w3c.dom.Node evalNode) {

         org.w3c.dom.Node attrNode;
         psiData psiReferreddData;
         org.w3c.dom.Node pointedNode=null;

         //Check first if dsReference was called
         if ( checkIfDsReference(evalNode) )
             dsReference.eval(phData, evalNode);

         attrNode = evalNode.getAttributes().getNamedItem("URI");

         if (attrNode == null)
             attrNode = evalNode.getAttributes().getNamedItemNS(phData.wssSchemaURI, "URI");

         if (attrNode == null) {
             psiReferreddData = phiClass.retPsiData(
                     phData,
                     evalNode,
                     "ReferredData",
                     "The marked Reference element does not have a URI attribute. What does it point to?",
                     false,
                     null);

             //Check if an answer supplied and if not return
             if (psiReferreddData.getPsiDataValue().equals(""))
                 return ("");
             else
                 return(psiReferreddData.getPsiDataValue());
         }


         pointedNode = phiClass.myGetElementById(phData,
                                        phData.document.getDocumentElement(),
                                        attrNode.getNodeValue().substring(1));


         if (pointedNode == null) {
             psiReferreddData = phiClass.retPsiData(
                     phData,
                     evalNode,
                     "ReferredData",
                     "The marked Reference element points outside the document. What does it point to?",
                     false,
                     null);

             //Check if an answer supplied and if not return
             if (psiReferreddData.getPsiDataValue().equals(""))
                 return ("");
             else
                 return(psiReferreddData.getPsiDataValue());
         }


         return(phiClass.evaluateNode(phData, pointedNode));
     }


     /***********************************************
     * phi of Reference with two arguements
     ************************************************/
     public static String eval(phiData phData, org.w3c.dom.Node evalNode, String szArg) {

        org.w3c.dom.Node attrNode;
        psiData psiReferreddData;
        org.w3c.dom.Node pointedNode=null;

        //Check first if dsReference was called
        if ( checkIfDsReference(evalNode) )
            dsReference.eval(phData, evalNode, szArg);

        attrNode = evalNode.getAttributes().getNamedItem("URI");

        if (attrNode == null)
            attrNode = evalNode.getAttributes().getNamedItemNS(phData.wssSchemaURI, "URI");

        if (attrNode == null) {
            psiReferreddData = phiClass.retPsiData(
                    phData,
                    evalNode,
                    "ReferredData",
                    "The marked Reference element does not have a URI attribute. What does it point to?",
                    false,
                    null);

           //Check if an answer supplied and if not return
           if (psiReferreddData.getPsiDataValue().equals(""))
               return ("");
           else
               return(psiReferreddData.getPsiDataValue());
        }


        pointedNode = phiClass.myGetElementById(phData,
                                       phData.document.getDocumentElement(),
                                       attrNode.getNodeValue().substring(1));

        if (pointedNode == null) {
            psiReferreddData = phiClass.retPsiData(
                    phData,
                    evalNode,
                    "ReferredData",
                    "The marked Reference element points outside the document. What does it point to?",
                    false,
                    null);

            //Check if an answer supplied and if not return
            if (psiReferreddData.getPsiDataValue().equals(""))
                return ("");
            else
                return(psiReferreddData.getPsiDataValue());
        }

        if ( szArg.equals("SIGNATURE") )
           return(attrNode.getNodeValue());
        else if ( szArg.equals("TRANSFORM") )
           return(phiClass.evaluateNode(phData, pointedNode, "SIGNATURE"));
        else
           return(phiClass.evaluateNode(phData, pointedNode, szArg));
    }

    /*
       Since we have two different elements called Reference (dsig, wss)
       we need to check whether this element is the ds one or wss.

       If ds then we call dsReference to handle it.
    */
    private static boolean checkIfDsReference(org.w3c.dom.Node ReferenceNode){

        org.w3c.dom.Node indexNode, DigestMethodNode=null, DigestValueNode=null;
        org.w3c.dom.NodeList list;

         //Check first if dsReference was called
         list = ReferenceNode.getChildNodes();

         // Loop through the list.
         for (int i=0; i < list.getLength(); i++) {
             indexNode = list.item(i);
             if (indexNode.getNodeType() == indexNode.ELEMENT_NODE) {
                 if (indexNode.getLocalName().equals("DigestMethod"))
                     DigestMethodNode = indexNode;
                 if (indexNode.getLocalName().equals("DigestValue"))
                     DigestValueNode = indexNode;
             }
         }

         if ( list.getLength() > 0 && DigestMethodNode != null && DigestValueNode != null )
             return(true);
         else
             return(false);

    }
}
