package phi;

import javax.swing.JOptionPane;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
/*
 suelements

      - Transforms -> minOccur = 0
      - DigestMethod
      - DigestValue

 attributes (all optional)
      - Id
      - URI
      - Type
 */
public class dsReference {
    public dsReference() {
    }

    /***********************************************
     * phi of dsReference with one arguement
     ************************************************/
     public static String eval(phiData phData, org.w3c.dom.Node evalNode) {

         org.w3c.dom.Node attrNode, pointedNode=null;
         psiData psiReferreddData;
         String szDigestValue, szResult="";

         szDigestValue = getDigestValue(phData, evalNode);

         attrNode = evalNode.getAttributes().getNamedItem("URI");

          if (attrNode == null)
              attrNode = evalNode.getAttributes().getNamedItemNS(phData.xmlSigURI, "URI");

          if (attrNode == null && !phData.bAbstracted) {
             psiReferreddData = phiClass.retPsiData(
                     phData,
                     evalNode,
                     "ReferredData",
                     "The marked Reference element does not have a URI attribute. What does it point to?",
                     false,
                     null);

             //Check if an answer supplied and if not return
             if (psiReferreddData.getPsiDataValue().equals(""))
                 return ("");
             else
                 return("h(" + psiReferreddData.getPsiDataValue() + ")");
         }

         if (attrNode != null)
             pointedNode = phiClass.myGetElementById(phData,
                                                     phData.document.getDocumentElement(),
                                                     attrNode.getNodeValue().substring(1));


         if (pointedNode == null && !phData.bAbstracted) {
             psiReferreddData = phiClass.retPsiData(
                     phData,
                     evalNode,
                     "ReferredData",
                     "The marked Reference element points outside the document. What does it point to?",
                     false,
                     null);

             //Check if an answer supplied and if not return
             if (psiReferreddData.getPsiDataValue().equals(""))
                 return ("");
             else
                 return("h(" + psiReferreddData.getPsiDataValue() + ")");
         }

         if ( pointedNode != null) {
            if ( pointedNode.getLocalName().equals("SecurityTokenReference") &&
                 checkTranform(phData,evalNode) )
                szResult = "h(" + phiClass.evaluateNode(phData, pointedNode,"TRANSFORM") + ")";
            else
                szResult = "h(" + phiClass.evaluateNode(phData, pointedNode, "SIGNATURE") +")";

            if ( phData.bAbstracted ) {
                if ( !szDigestValue.equals(szResult) ) {
                    JOptionPane.showMessageDialog(null,
                                               "dsReference: inconsistency between DigestValue and Reference value",
                                               "Abort",
                                               JOptionPane.ERROR_MESSAGE);
                    phData.phiAborted = true;
                    return ("");
                }
            }
         } else if ( phData.bAbstracted ) {
             szResult = szDigestValue;
         }


         return(szResult);
     }

     /***********************************************
     * phi of dsReference with two arguements
     ************************************************/
     public static String eval(phiData phData, org.w3c.dom.Node evalNode, String szArg) {
         org.w3c.dom.Node attrNode, pointedNode=null;
         psiData psiReferreddData;
         String szDigestValue, szResult="";

         szDigestValue = getDigestValue(phData, evalNode);

         attrNode = evalNode.getAttributes().getNamedItem("URI");

          if (attrNode == null)
              attrNode = evalNode.getAttributes().getNamedItemNS(phData.xmlSigURI, "URI");

          if (attrNode == null && !phData.bAbstracted) {
             psiReferreddData = phiClass.retPsiData(
                     phData,
                     evalNode,
                     "ReferredData",
                     "The marked Reference element does not have a URI attribute. What does it point to?",
                     false,
                     null);

             //Check if an answer supplied and if not return
             if (psiReferreddData.getPsiDataValue().equals(""))
                 return ("");
             else
                 return("h(" + psiReferreddData.getPsiDataValue() + ")");
         }

         if (attrNode != null)
             pointedNode = phiClass.myGetElementById(phData,
                                                     phData.document.getDocumentElement(),
                                                     attrNode.getNodeValue().substring(1));


         if (pointedNode == null && !phData.bAbstracted) {
             psiReferreddData = phiClass.retPsiData(
                     phData,
                     evalNode,
                     "ReferredData",
                     "The marked Reference element points outside the document. What does it point to?",
                     false,
                     null);

             //Check if an answer supplied and if not return
             if (psiReferreddData.getPsiDataValue().equals(""))
                 return ("");
             else
                 return("h(" + psiReferreddData.getPsiDataValue() + ")");
         }

         if ( pointedNode != null) {
             szResult = "h(" + phiClass.evaluateNode(phData, pointedNode, szArg) + ")";

             if (phData.bAbstracted) {
                 if (!szDigestValue.equals(szResult)) {
                     JOptionPane.showMessageDialog(null,
                                                   "dsReference: inconsistency between DigestValue and Reference value",
                                                   "Abort",
                                                   JOptionPane.ERROR_MESSAGE);
                     phData.phiAborted = true;
                     return ("");

                 }
             }
         } else if ( phData.bAbstracted )
             szDigestValue = szResult;

         return(szResult);

     }



     /* chekcing whether this reference element indicate the STR-Transform

        Can have unbounded Transform elements
        and a required Algorithm attribute


       Returns true if there is STR-Transform indication
       and false otherwise
     */
     private static boolean checkTranform(phiData phData, org.w3c.dom.Node evalNode){

         org.w3c.dom.Node indexNode, indexNode2, attrNode;
         org.w3c.dom.NodeList list, tranfromList;

         list = evalNode.getChildNodes();

        // Loop through the list.
        for (int i=0; i < list.getLength(); i++) {
            indexNode = list.item(i);
            if (indexNode.getNodeType() == indexNode.ELEMENT_NODE) {
                if (indexNode.getLocalName().equals("Transforms")) {
                    tranfromList = indexNode.getChildNodes();
                    for (int j=0; j < tranfromList.getLength(); j++) {
                        indexNode2 = tranfromList.item(j);
                        if (indexNode2.getNodeType() == indexNode.ELEMENT_NODE &&
                        indexNode2.getLocalName().equals("Transform")) {
                            attrNode = indexNode2.getAttributes().getNamedItem("Algorithm");

                            if (attrNode == null)
                                attrNode = evalNode.getAttributes().getNamedItemNS(phData.xmlSigURI, "Algorithm");

                            if ( attrNode != null && attrNode.getNodeValue().endsWith("STR-Transform"))
                                return(true);
                        }
                    }
                }
            }
        }


         return(false);
     }


     private static String getDigestValue(phiData phData, org.w3c.dom.Node evalNode){

        org.w3c.dom.Node indexNode;
        org.w3c.dom.NodeList list;


        if ( !phData.bAbstracted )
            return("");

        list = evalNode.getChildNodes();

        // Loop through the list.
        for (int i=0; i < list.getLength(); i++) {
            indexNode = list.item(i);
            if (indexNode.getNodeType() == indexNode.ELEMENT_NODE) {
                if ( indexNode.getLocalName().equals("DigestValue") )
                   return(indexNode.getFirstChild().getNodeValue().trim());
            }
        }

        return("");

     }
}
