package phi;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.FactoryConfigurationError;
import javax.xml.parsers.ParserConfigurationException;

import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

import org.xml.sax.helpers.DefaultHandler;

import java.io.File;
import java.io.IOException;

import javax.swing.*;
import sud.*;


import org.w3c.dom.DOMException;
import org.w3c.dom.Document;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class parserClass {

        //Constants
        static final String JAXP_SCHEMA_LANGUAGE =
        "http://java.sun.com/xml/jaxp/properties/schemaLanguage";

        static final String W3C_XML_SCHEMA =
        "http://www.w3.org/2001/XMLSchema";

        static final String soapSchema = "soap-envelope.xsd";
        static final String wssSchema = "secext.xsd";
        static final String utilitySchema = "utility.xsd";

        static final String[] schemas = {
        soapSchema,
        utilitySchema,
        wssSchema,
        };

        static final String JAXP_SCHEMA_SOURCE =
        "http://java.sun.com/xml/jaxp/properties/schemaSource";


//        static phiData phData = new phiData();
        JFileChooser jFileChooser1 = new JFileChooser();

    public parserClass() {
    }


    public static void setParserConfiguration(phiData phData){
       //Initialize the XML document
       phData.factory = DocumentBuilderFactory.newInstance();
       phData.factory.setValidating(phData.bValidating);
       phData.factory.setNamespaceAware(true);

       try {

           if (phData.bValidating) {
               phData.factory.setAttribute(JAXP_SCHEMA_LANGUAGE, W3C_XML_SCHEMA);
               phData.factory.setAttribute(JAXP_SCHEMA_SOURCE, schemas);
           }
       } catch (IllegalArgumentException x) {
            // Happens if the parser does not support JAXP 1.2
            JOptionPane.showMessageDialog(
              phData.parent, "The parser does not support JAXP 1.2 -", "Error", JOptionPane.ERROR_MESSAGE);


       }


    }



    //The loading Soap function
    public static void loadXML(phiData phData)
    {

        phData.XMLParserNonFatalError = false;
        phData.XMLParserFatalError = false;
        phData.szParserLog = "";


        Validator handler = new Validator(phData);


        try {
           //System.out.println(factory.getAttribute(JAXP_SCHEMA_LANGUAGE));
           DocumentBuilder builder = phData.factory.newDocumentBuilder();
           builder.setErrorHandler(handler);
           phData.document = builder.parse( phData.fhSOAP );


        } catch (IllegalArgumentException x) {
            // Happens if the parser does not support JAXP 1.2
            phData.XMLParserFatalError = true;
            JOptionPane.showMessageDialog(
              phData.parent, "The parser does not support JAXP 1.2 -", "Error", JOptionPane.ERROR_MESSAGE);


        } catch (SAXParseException spe) {
           // Error generated by the parser (taken care of by the validator class)
           //JOptionPane.showMessageDialog(
           //   phData.parent,"Line " + spe.getLineNumber() + ": " + spe.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);


        } catch (SAXException sxe) {
           // Error generated during parsing)
           phData.XMLParserFatalError = true;
           Exception  x = sxe;
           if (sxe.getException() != null)
               x = sxe.getException();

           JOptionPane.showMessageDialog(
              phData.parent, "SAXException", "Error", JOptionPane.ERROR_MESSAGE);


        } catch (ParserConfigurationException pce) {
            // Parser with specified options can't be built
            phData.XMLParserFatalError = true;
            JOptionPane.showMessageDialog(
              phData.parent, "Parser with specified options can't be built", "Error", JOptionPane.ERROR_MESSAGE);


        } catch (IOException ioe) {
           // I/O error
           phData.XMLParserFatalError = true;
           JOptionPane.showMessageDialog(
              phData.parent, "I/O error check the validation of the input file.", "Error", JOptionPane.ERROR_MESSAGE);
        }
    }


}


class Validator extends DefaultHandler {

  private phiData localPhi;

  Validator(phiData phData) {

      localPhi = phData;
  }

  public void error(SAXParseException exception) throws SAXException {

     localPhi.XMLParserNonFatalError = true;
     localPhi.szParserLog =  localPhi.szParserLog.concat("Error: Line " +  exception.getLineNumber() + ": " + exception.getMessage() + "\n");

  }

  public void fatalError(SAXParseException exception) {

      localPhi.XMLParserFatalError = true;
      localPhi.szParserLog =  localPhi.szParserLog.concat("Faltal error: Line " +  exception.getLineNumber() + ": " + exception.getMessage() + "\n");
  }

  public void warning(SAXParseException exception) throws SAXException {
     localPhi.XMLParserNonFatalError = true;
     localPhi.szParserLog =  localPhi.szParserLog.concat("Warning: Line " +  exception.getLineNumber() + ": " + exception.getMessage() + "\n");
  }
}
