package sud;

import java.awt.BorderLayout;
import java.awt.Frame;

import javax.swing.JDialog;
import javax.swing.JPanel;
import com.borland.jbcl.layout.XYLayout;
import com.borland.jbcl.layout.*;
import javax.swing.JLabel;
import java.awt.Color;
import java.awt.Font;
import javax.swing.JCheckBox;
import javax.swing.JTextField;
import javax.swing.JButton;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class SUDFrame_ParserConfigureBox extends JDialog {

    SUDData localMdData;
    JPanel panel1 = new JPanel();
    XYLayout xYLayout1 = new XYLayout();
    JLabel jLabelTitle = new JLabel();
    JCheckBox jCheckBoxValidation = new JCheckBox();
    JButton jOk = new JButton();
    JButton jCancel = new JButton();
    JLabel jLabelErrorMsg = new JLabel();

    //SoapSchema elements
    JCheckBox jCheckBoxSoapSchema = new JCheckBox();
    JTextField jTextFileSoapSchema = new JTextField();
    JButton jButtonSoapSchema = new JButton();
    JButton jButtonSoapURI = new JButton();
    JLabel jLabelFileSoapSchema = new JLabel();
    JLabel jLabelURISoapSchema = new JLabel();
    JTextField jTextURISoapSchema = new JTextField();

    // UtilitySchema elements
    JCheckBox jCheckBoxUtilitySchema = new JCheckBox();
    JLabel jLabelURIUtilitySchema = new JLabel();
    JTextField jTextURIUtilitySchema = new JTextField();
    JTextField jTextFileUtilitySchema = new JTextField();
    JLabel jLabelFileUtilitySchema = new JLabel();
    JButton jButtonUtilitySchema = new JButton();
    JButton jButtonUtilityURI = new JButton();

    // WssSchema elements
    JCheckBox jCheckBoxWssSchema = new JCheckBox();
    JLabel jLabelURIWssSchema = new JLabel();
    JTextField jTextURIWssSchema = new JTextField();
    JTextField jTextFileWssSchema = new JTextField();
    JLabel jLabelFileWssSchema = new JLabel();
    JButton jButtonWssSchema = new JButton();
    JButton jButtonWssURI = new JButton();

    // XmlEnc elements
    JCheckBox jCheckBoxXmlEnc = new JCheckBox();
    JLabel jLabelURIXmlEnc = new JLabel();
    JTextField jTextURIXmlEnc = new JTextField();
    JTextField jTextFileXmlEnc = new JTextField();
    JLabel jLabelFileXmlEnc = new JLabel();
    JButton jButtonXmlEnc = new JButton();
    JButton jButtonXmlEncURI = new JButton();

    // XmlSig elements
    JCheckBox jCheckBoxXmlSig = new JCheckBox();
    JLabel jLabelURIXmlSig = new JLabel();
    JTextField jTextURIXmlSig = new JTextField();
    JTextField jTextFileXmlSig = new JTextField();
    JLabel jLabelFileXmlSig = new JLabel();
    JButton jButtonXmlSig = new JButton();
    JButton jButtonXmlSigURI = new JButton();




    public SUDFrame_ParserConfigureBox(Frame owner, SUDData mdData) {
        super(owner, "Parser Configuration", false);
        try {
            setDefaultCloseOperation(DISPOSE_ON_CLOSE);
            localMdData = mdData;
            jbInit();
            pack();
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        panel1.setLayout(xYLayout1);
        jLabelTitle.setFont(new java.awt.Font("SansSerif", Font.BOLD, 16));
        jLabelTitle.setForeground(Color.blue);
        jLabelTitle.setText("Parser configuration");
        jCheckBoxValidation.setFont(new java.awt.Font("SansSerif", Font.PLAIN, 12));
        jCheckBoxValidation.setText("Schema Validation");
        jCheckBoxValidation.addActionListener(new
                SUDFrame_ParserConfigureBox_jCheckBoxValidation_actionAdapter(this));
        jOk.setText("OK");
        jOk.addActionListener(new SUDFrame_ParserConfigureBox_jOk_actionAdapter(this));
        jCancel.setText("Cancel");
        jCancel.addActionListener(new
                SUDFrame_ParserConfigureBox_jCancel_actionAdapter(this));
        jLabelErrorMsg.setFont(new java.awt.Font("SansSerif", Font.PLAIN, 14));
        jLabelErrorMsg.setForeground(Color.red);
        jLabelErrorMsg.setText(" ");

        //SoapSchema elements
        jCheckBoxSoapSchema.setFont(new java.awt.Font("SansSerif", Font.PLAIN, 12));
        jCheckBoxSoapSchema.setText("soap Schema");
        if ( localMdData.soapSchemaValidate )
            jCheckBoxSoapSchema.setSelected(true);
        jTextFileSoapSchema.setFont(new java.awt.Font("SansSerif", Font.PLAIN, 12));
        jTextFileSoapSchema.setText(localMdData.soapSchemaFILE);
        jButtonSoapSchema.setText("Browse");
        jButtonSoapSchema.addActionListener(new
                SUDFrame_ParserConfigureBox_jButtonChangeSchema_actionAdapter(this));
        jButtonSoapURI.setText("Get URI");
        jButtonSoapURI.addActionListener(new
                SUDFrame_ParserConfigureBox_jButtonChangeURI_actionAdapter(this));
        jLabelFileSoapSchema.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
        jLabelFileSoapSchema.setText("File:");
        jLabelURISoapSchema.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
        jLabelURISoapSchema.setText("URI:");
        jTextURISoapSchema.setText(localMdData.soapSchemaURI);

        //utilitySchema elements
        jCheckBoxUtilitySchema.setFont(new java.awt.Font("SansSerif", Font.PLAIN, 12));
        jCheckBoxUtilitySchema.setText("utilitySchema");
        if ( localMdData.utilitySchemaValidate )
            jCheckBoxUtilitySchema.setSelected(true);
        jTextFileUtilitySchema.setFont(new java.awt.Font("SansSerif", Font.PLAIN, 12));
        jTextFileUtilitySchema.setText(localMdData.utilitySchemaFILE);
        jButtonUtilitySchema.setText("Browse");
        jButtonUtilitySchema.addActionListener(new
                SUDFrame_ParserConfigureBox_jButtonChangeSchema_actionAdapter(this));
        jButtonUtilityURI.setText("Get URI");
        jButtonUtilityURI.addActionListener(new
                SUDFrame_ParserConfigureBox_jButtonChangeURI_actionAdapter(this));
        jLabelFileUtilitySchema.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
        jLabelFileUtilitySchema.setText("File:");
        jLabelURIUtilitySchema.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
        jLabelURIUtilitySchema.setText("URI:");
        jTextURIUtilitySchema.setText(localMdData.utilitySchemaURI);


        //utilitySchema elements
        jCheckBoxWssSchema.setFont(new java.awt.Font("SansSerif", Font.PLAIN, 12));
        jCheckBoxWssSchema.setText("wssSchema");
        if ( localMdData.wssSchemaValidate )
            jCheckBoxWssSchema.setSelected(true);
        jTextFileWssSchema.setFont(new java.awt.Font("SansSerif", Font.PLAIN, 12));
        jTextFileWssSchema.setText(localMdData.wssSchemaFILE);
        jButtonWssSchema.setText("Browse");
        jButtonWssSchema.addActionListener(new
                SUDFrame_ParserConfigureBox_jButtonChangeSchema_actionAdapter(this));
        jButtonWssURI.setText("Get URI");
        jButtonWssURI.addActionListener(new
                SUDFrame_ParserConfigureBox_jButtonChangeURI_actionAdapter(this));
        jLabelFileWssSchema.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
        jLabelFileWssSchema.setText("File:");
        jLabelURIWssSchema.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
        jLabelURIWssSchema.setText("URI:");
        jTextURIWssSchema.setText(localMdData.wssSchemaURI);


        //xmlEnc elements
        jCheckBoxXmlEnc.setFont(new java.awt.Font("SansSerif", Font.PLAIN, 12));
        jCheckBoxXmlEnc.setText("xmlEnc");
        if ( localMdData.xmlEncValidate )
            jCheckBoxXmlEnc.setSelected(true);
        jTextFileXmlEnc.setFont(new java.awt.Font("SansSerif", Font.PLAIN, 12));
        jTextFileXmlEnc.setText(localMdData.xmlEncFILE);
        jButtonXmlEnc.setText("Browse");
        jButtonXmlEnc.addActionListener(new
           SUDFrame_ParserConfigureBox_jButtonChangeSchema_actionAdapter(this));
        jButtonXmlEncURI.setText("Get URI");
        jButtonXmlEncURI.addActionListener(new
                SUDFrame_ParserConfigureBox_jButtonChangeURI_actionAdapter(this));
        jLabelFileXmlEnc.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
        jLabelFileXmlEnc.setText("File:");
        jLabelURIXmlEnc.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
        jLabelURIXmlEnc.setText("URI:");
        jTextURIXmlEnc.setText(localMdData.xmlEncURI);

        //xmlSig elements
        jCheckBoxXmlSig.setFont(new java.awt.Font("SansSerif", Font.PLAIN, 12));
        jCheckBoxXmlSig.setText("xmlSig");
        if ( localMdData.xmlSigValidate )
            jCheckBoxXmlSig.setSelected(true);
        jTextFileXmlSig.setFont(new java.awt.Font("SansSerif", Font.PLAIN, 12));
        jTextFileXmlSig.setText(localMdData.xmlSigFILE);
        jButtonXmlSig.setText("Browse");
        jButtonXmlSig.addActionListener(new
                SUDFrame_ParserConfigureBox_jButtonChangeSchema_actionAdapter(this));
        jButtonXmlSigURI.setText("Get URI");
        jButtonXmlSigURI.addActionListener(new
                SUDFrame_ParserConfigureBox_jButtonChangeURI_actionAdapter(this));
        jLabelFileXmlSig.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
        jLabelFileXmlSig.setText("File:");
        jLabelURIXmlSig.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
        jLabelURIXmlSig.setText("URI:");
        jTextURIXmlSig.setText(localMdData.xmlSigURI);




        this.getContentPane().add(panel1, java.awt.BorderLayout.CENTER);
        panel1.add(jLabelTitle, new XYConstraints(18, 11, 440, 26));
        panel1.add(jCheckBoxValidation, new XYConstraints(22, 53, 138, 22));
        panel1.add(jOk, new XYConstraints(140, 500, -1, -1));
        panel1.add(jCancel, new XYConstraints(235, 500, -1, -1));
        panel1.add(jLabelErrorMsg, new XYConstraints(18, 527, -1, -1));

        //soapSchema elements
        panel1.add(jCheckBoxSoapSchema, new XYConstraints(22, 82, -1, -1));
        panel1.add(jButtonSoapSchema, new XYConstraints(363, 106, -1, -1));
        panel1.add(jButtonSoapURI, new XYConstraints(363, 133, -1, -1));
        panel1.add(jTextFileSoapSchema, new XYConstraints(75, 108, 285, -1));
        panel1.add(jLabelFileSoapSchema, new XYConstraints(44, 107, 30, 21));
        panel1.add(jTextURISoapSchema, new XYConstraints(75, 135, 285, -1));
        panel1.add(jLabelURISoapSchema, new XYConstraints(44, 134, 28, 20));

        //UtilitySchema elements
        panel1.add(jCheckBoxUtilitySchema, new XYConstraints(22, 164, -1, -1));
        panel1.add(jButtonUtilitySchema, new XYConstraints(363, 188, -1, -1));
        panel1.add(jButtonUtilityURI, new XYConstraints(363, 215, -1, -1));
        panel1.add(jTextFileUtilitySchema, new XYConstraints(75, 190, 285, -1));
        panel1.add(jLabelFileUtilitySchema, new XYConstraints(44, 189, 30, 21));
        panel1.add(jTextURIUtilitySchema, new XYConstraints(75, 217, 285, -1));
        panel1.add(jLabelURIUtilitySchema, new XYConstraints(44, 216, 28, 20));

        //UtilitySchema elements
        panel1.add(jCheckBoxWssSchema, new XYConstraints(22, 246, -1, -1));
        panel1.add(jButtonWssSchema, new XYConstraints(363, 270, -1, -1));
        panel1.add(jButtonWssURI, new XYConstraints(363, 297, -1, -1));
        panel1.add(jTextFileWssSchema, new XYConstraints(75, 272, 285, -1));
        panel1.add(jLabelFileWssSchema, new XYConstraints(44, 271, 30, 21));
        panel1.add(jTextURIWssSchema, new XYConstraints(75, 299, 285, -1));
        panel1.add(jLabelURIWssSchema, new XYConstraints(44, 298, 28, 20));

        //XmlEnc elements
        panel1.add(jCheckBoxXmlEnc, new XYConstraints(22, 328, -1, -1));
        panel1.add(jButtonXmlEnc, new XYConstraints(363, 352, -1, -1));
        panel1.add(jButtonXmlEncURI, new XYConstraints(363, 379, -1, -1));
        panel1.add(jTextFileXmlEnc, new XYConstraints(75, 354, 285, -1));
        panel1.add(jLabelFileXmlEnc, new XYConstraints(44, 353, 30, 21));
        panel1.add(jTextURIXmlEnc, new XYConstraints(75, 381, 285, -1));
        panel1.add(jLabelURIXmlEnc, new XYConstraints(44, 380, 28, 20));

        //XmlSig elements
        panel1.add(jCheckBoxXmlSig, new XYConstraints(22, 410, -1, -1));
        panel1.add(jButtonXmlSig, new XYConstraints(363, 434, -1, -1));
        panel1.add(jButtonXmlSigURI, new XYConstraints(363, 461, -1, -1));
        panel1.add(jTextFileXmlSig, new XYConstraints(75, 436, 285, -1));
        panel1.add(jLabelFileXmlSig, new XYConstraints(44, 435, 30, 21));
        panel1.add(jTextURIXmlSig, new XYConstraints(75, 463, 285, -1));
        panel1.add(jLabelURIXmlSig, new XYConstraints(44, 462, 28, 20));

        //General initiation
        if ( !localMdData.bValidating ) {

            jCheckBoxSoapSchema.setEnabled(false);
            jCheckBoxUtilitySchema.setEnabled(false);
            jCheckBoxWssSchema.setEnabled(false);
            jCheckBoxXmlEnc.setEnabled(false);
            jCheckBoxXmlSig.setEnabled(false);
        } else
            jCheckBoxValidation.setSelected(true);




    }

    public void jCancel_actionPerformed(ActionEvent e) {
        dispose();
    }

    public void jCheckBoxValidation_actionPerformed(ActionEvent e) {
       if (jCheckBoxValidation.isSelected()) {
            jCheckBoxSoapSchema.setEnabled(true);
            jCheckBoxUtilitySchema.setEnabled(true);
            jCheckBoxWssSchema.setEnabled(true);
            jCheckBoxXmlEnc.setEnabled(true);
            jCheckBoxXmlSig.setEnabled(true);
        } else {
            jCheckBoxSoapSchema.setEnabled(false);
            jCheckBoxUtilitySchema.setEnabled(false);
            jCheckBoxWssSchema.setEnabled(false);
            jCheckBoxXmlEnc.setEnabled(false);
            jCheckBoxXmlSig.setEnabled(false);
        }

    }

    public void jOk_actionPerformed(ActionEvent e) {
        SUDClass_EnvInit init = new SUDClass_EnvInit(localMdData);

        if (jCheckBoxValidation.isSelected())
            localMdData.bValidating = true;
        else
            localMdData.bValidating = false;

        if (localMdData.bValidating && jCheckBoxSoapSchema.isSelected()){
            if ( jTextFileSoapSchema.getText().matches("") ) {
                jLabelErrorMsg.setText("Soap schema cannot be validated with out schema supplied");
                return;
            } else if ( init.getSchemaName(jTextFileSoapSchema.getText()).matches("") ) {
                jLabelErrorMsg.setText("Invalid Soap schema supplied");
                return;
            } else
                localMdData.soapSchemaValidate = true;
        } else
            localMdData.soapSchemaValidate = false;


        if (localMdData.bValidating && jCheckBoxUtilitySchema.isSelected()){
            if ( jTextFileUtilitySchema.getText().matches("") ) {
                jLabelErrorMsg.setText("Utility schema cannot be validated with out schema supplied");
                return;
            } else if ( init.getSchemaName(jTextFileUtilitySchema.getText()).matches("") ) {
                jLabelErrorMsg.setText("Invalid Utility schema supplied");
                return;
            } else
                localMdData.utilitySchemaValidate = true;
        } else
            localMdData.utilitySchemaValidate = false;


        if (localMdData.bValidating && jCheckBoxWssSchema.isSelected()){
            if ( jTextFileWssSchema.getText().matches("") ) {
                jLabelErrorMsg.setText("Wss schema cannot be validated with out schema supplied");
                return;
            } else if ( init.getSchemaName(jTextFileWssSchema.getText()).matches("") ) {
                jLabelErrorMsg.setText("Invalid Wss schema supplied");
                return;
            } else
                localMdData.wssSchemaValidate = true;
        } else
            localMdData.wssSchemaValidate = false;


        if (localMdData.bValidating && jCheckBoxXmlEnc.isSelected()){
            if ( jTextFileXmlEnc.getText().matches("") ) {
                jLabelErrorMsg.setText("XmlEnc schema cannot be validated with out schema supplied");
                return;
            } else if ( init.getSchemaName(jTextFileXmlEnc.getText()).matches("") ) {
                jLabelErrorMsg.setText("Invalid XmlEnc schema supplied");
                return;
            } else
                localMdData.xmlEncValidate = true;
        } else
            localMdData.xmlEncValidate = false;


        if (localMdData.bValidating && jCheckBoxXmlSig.isSelected()){
            if ( jTextFileXmlSig.getText().matches("") ) {
                jLabelErrorMsg.setText("XmlSig schema cannot be validated with out schema supplied");
                return;
            } else if ( init.getSchemaName(jTextFileXmlSig.getText()).matches("") ) {
                jLabelErrorMsg.setText("Invalid XmlSig schema supplied");
                return;
            } else
                localMdData.xmlSigValidate = true;
        } else
            localMdData.xmlSigValidate = false;


        localMdData.soapSchemaFILE = jTextFileSoapSchema.getText();
        localMdData.soapSchemaURI = jTextURISoapSchema.getText();

        localMdData.utilitySchemaFILE = jTextFileUtilitySchema.getText();
        localMdData.utilitySchemaURI = jTextURIUtilitySchema.getText();

        localMdData.wssSchemaFILE = jTextFileWssSchema.getText();
        localMdData.wssSchemaURI = jTextURIWssSchema.getText();

        localMdData.xmlEncFILE = jTextFileXmlEnc.getText();
        localMdData.xmlEncURI = jTextURIXmlEnc.getText();

        localMdData.xmlSigFILE = jTextFileXmlSig.getText();
        localMdData.xmlSigURI = jTextURIXmlSig.getText();

        localMdData.parserConfigurationLoaded = true;

        dispose();
    }

}




class SUDFrame_ParserConfigureBox_jCheckBoxValidation_actionAdapter implements
        ActionListener {
    private SUDFrame_ParserConfigureBox adaptee;
    SUDFrame_ParserConfigureBox_jCheckBoxValidation_actionAdapter(
            SUDFrame_ParserConfigureBox adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCheckBoxValidation_actionPerformed(e);
    }
}


class SUDFrame_ParserConfigureBox_jOk_actionAdapter implements ActionListener {
    private SUDFrame_ParserConfigureBox adaptee;
    SUDFrame_ParserConfigureBox_jOk_actionAdapter(SUDFrame_ParserConfigureBox
                                                  adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jOk_actionPerformed(e);
    }
}


class SUDFrame_ParserConfigureBox_jButtonChangeURI_actionAdapter implements
        ActionListener {
    private SUDFrame_ParserConfigureBox adaptee;
    SUDFrame_ParserConfigureBox_jButtonChangeURI_actionAdapter(
            SUDFrame_ParserConfigureBox adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        SUDClass_EnvInit init = new SUDClass_EnvInit(adaptee.localMdData);
        String szSchemaName="";

        if ( e.getSource() == adaptee.jButtonSoapURI && !adaptee.jTextFileSoapSchema.getText().matches("") ){
            szSchemaName = init.getSchemaName(adaptee.jTextFileSoapSchema.getText());
            adaptee.jTextURISoapSchema.setText(szSchemaName);
        } else if ( e.getSource() == adaptee.jButtonUtilityURI && !adaptee.jTextFileUtilitySchema.getText().matches("") ){
            szSchemaName = init.getSchemaName(adaptee.jTextFileUtilitySchema.getText());
            adaptee.jTextURIUtilitySchema.setText(szSchemaName);
        } else if ( e.getSource() == adaptee.jButtonWssURI && !adaptee.jTextFileWssSchema.getText().matches("") ){
            szSchemaName = init.getSchemaName(adaptee.jTextFileWssSchema.getText());
            adaptee.jTextURIWssSchema.setText(szSchemaName);
        } else if ( e.getSource() == adaptee.jButtonXmlEncURI && !adaptee.jTextFileXmlEnc.getText().matches("") ){
            szSchemaName = init.getSchemaName(adaptee.jTextFileXmlEnc.getText());
            adaptee.jTextURIXmlEnc.setText(szSchemaName);
        } else if ( e.getSource() == adaptee.jButtonXmlSigURI && !adaptee.jTextFileXmlSig.getText().matches("") ){
            szSchemaName = init.getSchemaName(adaptee.jTextFileXmlSig.getText());
            adaptee.jTextURIXmlSig.setText(szSchemaName);
        }

        if ( szSchemaName.matches("") )
               JOptionPane.showMessageDialog(
                    adaptee, "Invalid Schema", "Error", JOptionPane.ERROR_MESSAGE);






    }
}


class SUDFrame_ParserConfigureBox_jButtonChangeSchema_actionAdapter implements
        ActionListener {
    private SUDFrame_ParserConfigureBox adaptee;
    SUDFrame_ParserConfigureBox_jButtonChangeSchema_actionAdapter(
            SUDFrame_ParserConfigureBox adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
       JFileChooser jFileChooser1 = new JFileChooser();
       SUDClass_EnvInit init = new SUDClass_EnvInit(adaptee.localMdData);
       String szPath = null, szSchemaName="";

       if (JFileChooser.APPROVE_OPTION == jFileChooser1.showOpenDialog(adaptee)) {
           szPath = jFileChooser1.getSelectedFile().getPath();
           szSchemaName = init.getSchemaName(szPath);

           if ( szSchemaName.matches("") )
               JOptionPane.showMessageDialog(
                    adaptee, "Invalid Schema", "Error", JOptionPane.ERROR_MESSAGE);

           if ( !szSchemaName.matches("")  && e.getSource() == adaptee.jButtonSoapSchema ) {
               adaptee.jTextFileSoapSchema.setText(szPath);
               adaptee.jTextURISoapSchema.setText(szSchemaName);
           } else if ( !szSchemaName.matches("")  && e.getSource() == adaptee.jButtonUtilitySchema ) {
               adaptee.jTextFileUtilitySchema.setText(szPath);
               adaptee.jTextURIUtilitySchema.setText(szSchemaName);
           } else if ( !szSchemaName.matches("")  && e.getSource() == adaptee.jButtonWssSchema ) {
               adaptee.jTextFileWssSchema.setText(szPath);
               adaptee.jTextURIWssSchema.setText(szSchemaName);
           } else if ( !szSchemaName.matches("")  && e.getSource() == adaptee.jButtonXmlEnc ) {
               adaptee.jTextFileXmlEnc.setText(szPath);
               adaptee.jTextURIXmlEnc.setText(szSchemaName);
           } else if ( !szSchemaName.matches("")  && e.getSource() == adaptee.jButtonXmlSig ) {
               adaptee.jTextFileXmlSig.setText(szPath);
               adaptee.jTextURIXmlSig.setText(szSchemaName);
           }

       }

    }
}


class SUDFrame_ParserConfigureBox_jCancel_actionAdapter implements
        ActionListener {
    private SUDFrame_ParserConfigureBox adaptee;
    SUDFrame_ParserConfigureBox_jCancel_actionAdapter(
            SUDFrame_ParserConfigureBox adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCancel_actionPerformed(e);
    }
}
