package casper;

import javax.swing.JOptionPane;
import java.util.StringTokenizer;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class FreeVarsLine {

    boolean bLineLoaded=false;

    boolean isVarDefinition = false;
    boolean isInverseKeys = false;

    String szLineContent;
    String szVars="";
    String szType = "";
    String szInverseKeys = "";
    String szKeys = "";

    public FreeVarsLine() {
    }

    //This method parse a line
    //and update the data structure with
    //the right values
    public void setLine(String szLine){

        String szErrorMsg = "", szTempKey, szSecondWord;;
        szLineContent = szLine;

        if ( szLine.trim().startsWith("--") ||
             szLine.trim().equals("") ||
             szLine.trim().startsWith("#")) {

           bLineLoaded = true;
        } else if ( szLine.trim().startsWith("InverseKeys") ){

            szSecondWord = casperClass.getSecondWord(szLine.trim());

            if ( szLine.trim().charAt(11) == '=' ||
                 szSecondWord.equals("=") ||
                 szSecondWord.startsWith("=") )
                szInverseKeys = szLine.substring(szLine.indexOf('=') + 1).trim();
            else
               szErrorMsg = "FreeVarsLine: '=' could not be found after InverseKeys\n";

           if ( szErrorMsg.equals("") ) {
               szInverseKeys = szInverseKeys.concat(",");
               while ( !szInverseKeys.equals("") ) {
                   szTempKey = getFirstKeyFromInverse(szInverseKeys);

                   if ( !szTempKey.equals("") ) {
                       szKeys = szKeys.concat(szTempKey + ", ");
                       szInverseKeys = szInverseKeys.substring(szInverseKeys.indexOf(')') + 1).trim();
                       if ( szInverseKeys.charAt(0) == ',' )
                           szInverseKeys = szInverseKeys.substring(1).trim();
                       else {
                           szErrorMsg = "FreeVarsLine: ',' could not be found after InverseKeys\n";
                           szKeys = "";
                           szInverseKeys = "";
                       }
                   } else {
                       szKeys = "";
                       szInverseKeys = "";
                   }
               }
           } else
               szErrorMsg = "FreeVarsLine: empty InverseKeys list\n";

           if ( !szKeys.equals("") ) {
               isInverseKeys = true;
               bLineLoaded = true;
           } else
               JOptionPane.showMessageDialog(null,
                                             szLineContent + " - " + szErrorMsg, "Error",
                                             JOptionPane.ERROR_MESSAGE);


        } else {

           if ( szLine.indexOf(':') > 0 )
              szVars = szLine.trim().substring(0,szLine.indexOf(':'));
           else
               szErrorMsg = "FreeVarsLine: ':' could not be found in definition\n";

           if ( !szVars.equals("") )
               szType = szLine.substring(szLine.indexOf(':') + 1).trim();
           else
               szErrorMsg = "FreeVarsLine: no type";

           if ( !szVars.equals("") ) {
              isVarDefinition = true;
              bLineLoaded = true;
           }
           else
               JOptionPane.showMessageDialog(null,
                                             szLineContent + " - " + szErrorMsg, "Error",
                                             JOptionPane.ERROR_MESSAGE);
        }
    }

    //if var definition returns the number of vars defined in this line
    public int getVarsNumber() {

        StringTokenizer st;

        if ( isVarDefinition ) {
            st = new StringTokenizer(szVars.replaceAll(",", " "));
            return(st.countTokens());
        } else {
            System.err.println(
                    "debug(FreeVarsLine): getVarsNumber was called in a non-vars line");
            return(0);
        }
    }

    //Get the first key in the inverseKey string
    private String getFirstKeyFromInverse(String szInverseKeys) {

        String szKey = "", szErrorMsg = "", szInverse = "";

        if ( szInverseKeys.charAt(0) == '(' && szInverseKeys.indexOf(',') > 0)
            szKey = szInverseKeys.substring(1, szInverseKeys.indexOf(','));
        else
            szErrorMsg = "getFirstKeyFromInverse: '('  or ',' could not be found in Inverse Keys\n";

        if ( szKey.equals("") )
           szErrorMsg = "getFirstKeyFromInverse: empty key \n";

        if ( !szKey.equals("") && szInverseKeys.indexOf(')') > szInverseKeys.indexOf(',') )
            szInverse = szInverseKeys.substring(szInverseKeys.indexOf(',') + 1, szInverseKeys.indexOf(')'));
        else
            szErrorMsg = "getFirstKeyFromInverse: ')' could not be found in Inverse Keys\n";

        if ( szInverse.equals("") )
            JOptionPane.showMessageDialog(null,
                                             szErrorMsg, "Error",
                                             JOptionPane.ERROR_MESSAGE);

        return(szKey);

    }

}
