package phi;

import javax.swing.JOptionPane;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
/*
 suelements

      - EncrryptionMethod -> minOccur = 0
      - KeyInfo -> minOccur = 0
      - CipherData
      - EncryptoinProperties -> minOccur = 0

 attributes (all optional)
      - Id
      - Type
      - MimeType
      - Encoding
 */
public class EncryptedData {
    public EncryptedData() {
    }

    /***********************************************
     * phi of EncryptedData with one arguement
     ************************************************/
    public static String eval(phiData phData, org.w3c.dom.Node evalNode) {

        String szEncryptedData="", szCipherResult="", szEncrypting=null, szResult="";
        psiData psiEncryptedData;

        org.w3c.dom.Node indexNode,KeyInfoNode=null, EncryptionMethodNode=null;
        org.w3c.dom.NodeList list;

        if (!phData.bAbstracted) {
            psiEncryptedData = phiClass.retPsiData(phData,
                                                   evalNode,
                                                   "EncryptedData",
                                                   "Please specify the encrypted data in the CipherData in the marked of EncryptedData element.",
                                                   true,
                                                   null);

            szEncryptedData = psiEncryptedData.getPsiDataValue();

            //Check if a key supplied and if not return
            if (szEncryptedData.equals(""))
                return ("");
        }

        list = evalNode.getChildNodes();

        // Loop through the list.
        for (int i=0; i < list.getLength(); i++) {
            indexNode = list.item(i);
            if (indexNode.getNodeType() == indexNode.ELEMENT_NODE) {
                if (indexNode.getLocalName().equals("KeyInfo")) {
                    KeyInfoNode = indexNode;
                }  else if (indexNode.getLocalName().equals("EncryptionMethod")) {
                    EncryptionMethodNode = indexNode;
                } else if (indexNode.getLocalName().equals("CipherData")) {
                    if (phData.bAbstracted) {
                        szCipherResult = phiClass.evaluateNode(phData, indexNode);
                        szEncryptedData = checkCipherData(phData, szCipherResult, evalNode);
                        if ( szEncryptedData.equals("") )
                            return("");
                    }
                }
            }
        }

        if (KeyInfoNode == null){

            szEncrypting = checkContext(phData, evalNode);
            if ( szEncrypting != null )
                phiClass.saveAbstractedPsiData(phData, evalNode, szEncrypting, "Encrypting", phData.phiIsSymmetric(szEncrypting));
        }

        if (KeyInfoNode != null){

            szEncrypting = phiClass.evaluateNode(phData, KeyInfoNode, "ENC");

            if ( szEncrypting.matches("") )
                return("");
            else
                phiClass.saveAbstractedPsiData(phData, evalNode, szEncrypting, "Encrypting", phData.phiIsSymmetric(szEncrypting));


            //Check if the abstracted values in the SOAP message are consistent
            if ( !isConsistent(phData, szCipherResult, szEncryptedData, szEncrypting) )
                return("");

            szResult = phiClass.evaluateNode(phData, KeyInfoNode) + ", ";

            if ( szResult.trim().equals(",") )
                szResult = "";

        } else if ( !(szEncrypting == null || szEncrypting.equals("")) ) {

            //Check the consistency of szEncrypting
            if ( !isConsistent(phData, szCipherResult, szEncryptedData, szEncrypting) )
                return("");

        } else if (!phData.bAbstracted) {

            szEncrypting = checkKeyInfo(phData, evalNode, EncryptionMethodNode);

            if (szEncrypting.equals(""))
                return("");

        } else {
           //Check first if EncryptionMethod elemnt exists and indicate if the encrypting
           //key symmetric or not
           String szIsSmetric = evalEncryptionMethod(phData, EncryptionMethodNode);

           szEncrypting = szCipherResult.substring(szCipherResult.lastIndexOf('{') + 1, szCipherResult.lastIndexOf('}'));
           if ( (szEncrypting.startsWith("PK(") || szEncrypting.startsWith("SK(")) && szEncrypting.length() > 4 && szEncrypting.endsWith(")") ) {
               if ( szIsSmetric.equalsIgnoreCase("Yes") ){
                   JOptionPane.showMessageDialog(null,"EncryptedData: Inconsistency between the EncryptionMethod and in encrypting key in CipherData" ,"Abort" , JOptionPane.ERROR_MESSAGE);
                   phData.phiAborted = true;
                   return("");
               }
               phiClass.saveAbstractedPsiData(phData, evalNode, szEncrypting, "Encrypting", false);
           }
           else {
               if ( szIsSmetric.equalsIgnoreCase("No") ){
                   JOptionPane.showMessageDialog(null,"EncryptedData: Inconsistency between the EncryptionMethod and in encrypting key in CipherData" ,"Abort" , JOptionPane.ERROR_MESSAGE);
                   phData.phiAborted = true;
                   return("");
               }
               phiClass.saveAbstractedPsiData(phData, evalNode, szEncrypting, "Encrypting", true);
           }
       }

       szResult = szResult.concat("{" + szEncryptedData + "}{" + szEncrypting +"}");

       return(szResult);
   }


   /***********************************************
     * phi of EncryptedData with two arguements
     ************************************************/
    public static String eval(phiData phData, org.w3c.dom.Node evalNode, String szArg) {

        String szEncryptedData="", szCipherResult="", szEncrypting=null, szResult="";
        psiData psiEncryptedData;

        org.w3c.dom.Node indexNode,KeyInfoNode=null, EncryptionMethodNode=null;
        org.w3c.dom.NodeList list;

        if (!phData.bAbstracted) {
            psiEncryptedData = phiClass.retPsiData(phData,
                                                   evalNode,
                                                   "EncryptedData",
                                                   "Please specify the encrypted data in the CipherData in the marked of EncryptedData element.",
                                                   true,
                                                   null);

            szEncryptedData = psiEncryptedData.getPsiDataValue();

            //Check if a key supplied and if not return
            if (szEncryptedData.equals(""))
                return ("");
        }

        list = evalNode.getChildNodes();

        // Loop through the list.
        for (int i=0; i < list.getLength(); i++) {
            indexNode = list.item(i);
            if (indexNode.getNodeType() == indexNode.ELEMENT_NODE) {
                if (indexNode.getLocalName().equals("KeyInfo")) {
                    KeyInfoNode = indexNode;
                }  else if (indexNode.getLocalName().equals("EncryptionMethod")) {
                    EncryptionMethodNode = indexNode;
                } else if (indexNode.getLocalName().equals("CipherData")) {
                    if (phData.bAbstracted) {
                        szCipherResult = phiClass.evaluateNode(phData, indexNode);
                        szEncryptedData = checkCipherData(phData, szCipherResult, evalNode);
                        if ( szEncryptedData.equals("") )
                            return("");
                    }
                }
            }
        }

        if (KeyInfoNode == null) {
            szEncrypting = checkContext(phData, evalNode);
            if ( szEncrypting != null )
                phiClass.saveAbstractedPsiData(phData, evalNode, szEncrypting, "Encrypting", phData.phiIsSymmetric(szEncrypting));
        }

        if ( szArg.equals("SIGNATURE") && szEncrypting == null )
           if ( isPointedByDataReference(phData, evalNode) )
               return(szEncryptedData);

        if (KeyInfoNode != null){

            szEncrypting = phiClass.evaluateNode(phData, KeyInfoNode, "ENC");

            if ( szEncrypting.matches("") )
                return("");
            else
                phiClass.saveAbstractedPsiData(phData, evalNode, szEncrypting, "Encrypting", phData.phiIsSymmetric(szEncrypting));


            //Check if the abstracted values in the SOAP message are consistent
            if ( !isConsistent(phData, szCipherResult, szEncryptedData, szEncrypting) )
                return("");

            szResult = phiClass.evaluateNode(phData, KeyInfoNode) + ", ";

            if ( szResult.trim().equals(",") )
                szResult = "";

        } else if ( !(szEncrypting == null || szEncrypting.equals("")) ) {

            //Check the consistency of szEncrypting
            if ( !isConsistent(phData, szCipherResult, szEncryptedData, szEncrypting) )
                return("");

        } else if (!phData.bAbstracted) {

            szEncrypting = checkKeyInfo(phData, evalNode, EncryptionMethodNode);

            if (szEncrypting.equals(""))
                return("");

        } else {
           //Check first if EncryptionMethod elemnt exists and indicate if the encrypting
           //key symmetric or not
           String szIsSmetric = evalEncryptionMethod(phData, EncryptionMethodNode);

           szEncrypting = szCipherResult.substring(szCipherResult.lastIndexOf('{') + 1, szCipherResult.lastIndexOf('}'));
           if ( (szEncrypting.startsWith("PK(") || szEncrypting.startsWith("SK(")) && szEncrypting.length() > 4 && szEncrypting.endsWith(")") ) {
               if ( szIsSmetric.equalsIgnoreCase("Yes") ){
                   JOptionPane.showMessageDialog(null,"EncryptedData: Inconsistency between the EncryptionMethod and in encrypting key in CipherData" ,"Abort" , JOptionPane.ERROR_MESSAGE);
                   phData.phiAborted = true;
                   return("");
               }
               phiClass.saveAbstractedPsiData(phData, evalNode, szEncrypting, "Encrypting", false);
           }
           else {
               if ( szIsSmetric.equalsIgnoreCase("No") ){
                   JOptionPane.showMessageDialog(null,"EncryptedData: Inconsistency between the EncryptionMethod and in encrypting key in CipherData" ,"Abort" , JOptionPane.ERROR_MESSAGE);
                   phData.phiAborted = true;
                   return("");
               }
               phiClass.saveAbstractedPsiData(phData, evalNode, szEncrypting, "Encrypting", true);
           }
       }

       szResult = szResult.concat("{" + szEncryptedData + "}{" + szEncrypting +"}");

       return(szResult);
   }



   //Check the validity of the CipherData value
    private static String checkCipherData(phiData phData,
                                          String szCipherResult,
                                          org.w3c.dom.Node encryptedDataNode){

        String szEncryptedData;
        int indexOfFirstClose=-1, nBracketsToClose=1;

        szCipherResult = szCipherResult.trim();

        for (int i=1; i < szCipherResult.length(); i++) {

            if ( szCipherResult.charAt(i) == '{' )
                nBracketsToClose++;

            if ( szCipherResult.charAt(i) == '}' )
                nBracketsToClose--;

            if (nBracketsToClose == 0) {
                indexOfFirstClose = i;
                break;
            }
        }

        if (szCipherResult.charAt(0) == '{' &&
            indexOfFirstClose > 1 &&
            szCipherResult.lastIndexOf('{') ==
            indexOfFirstClose + 1 &&
            szCipherResult.lastIndexOf('}') ==
            szCipherResult.length() - 1) {

            szEncryptedData = szCipherResult.substring(1,indexOfFirstClose);
            phiClass.saveAbstractedPsiData(phData, encryptedDataNode, szEncryptedData, "EncryptedData",true);
            return(szEncryptedData);
        } else {
            JOptionPane.showMessageDialog(null,
                                          "EncryptedData: CipherData contains invalid text", "Abort",
                                          JOptionPane.ERROR_MESSAGE);
            phData.phiAborted = true;
            return ("");
        }

    }

    //Check the consistency of the encryptedData and encripting key with
    //the CipherData value in the case of abstract mode
    private static boolean isConsistent(phiData phData,
                                            String szCipherResult,
                                            String szEncryptedData,
                                            String szEncrypting){

        if (phData.bAbstracted) {
            if (!szCipherResult.equals("{" + szEncryptedData + "}{"+ szEncrypting +"}")) {
                    //inconsistency was discovered
                    JOptionPane.showMessageDialog(null,"EncryptedData: Inconsistency between CipherData and KeyInfo in EncryptedData element" ,"Abort" , JOptionPane.ERROR_MESSAGE);
                    phData.phiAborted = true;
                    return(false);
            }
        }

        return(true);
    }

    //This method checks whether a context exists meaing
    // that a DataReference element points to this element
    // if that is the case returns a key if exists in the context
    private static String checkContext(phiData phData,
                                       org.w3c.dom.Node evalNode){

        context nodeContext;
        org.w3c.dom.Node attrNode;

        attrNode = evalNode.getAttributes().getNamedItemNS(phData.utilitySchemaURI,"Id");

        if (attrNode == null)
            attrNode = evalNode.getAttributes().getNamedItem("Id");

        //Check if this node was already proccessed
        nodeContext = phData.phiRetContext(attrNode.getNodeValue());

        if (nodeContext.isContextEmpty())
            return (null);
        else
            return (nodeContext.getContextValue());



    }

    //This EncryptedData element does not have KeyInfo element
    //Ask the user for the encrypting
    //Key (In the case of Abstracted Message we already know it from the Cipher
    //Data element, so there is no need to ask
    private static String checkKeyInfo(phiData phData,
                                      org.w3c.dom.Node evalNode,
                                      org.w3c.dom.Node EncryptionMethodNode) {
        String szEncrypting="", szIsSmetric;
        String[] options = {"Yes", "No"};
        psiData psiEncryptingKey, psiIsSymetric;

        szIsSmetric = evalEncryptionMethod(phData, EncryptionMethodNode);

        if ( szIsSmetric.equals("") ) {
            psiIsSymetric = phiClass.retPsiData(
                    phData,
                    evalNode,
                    "Symetric",
                    "The encrypting key of the marked EncryptedData seems to be agreed applicatively. Is it Symetric key (yes/no)",
                    false,
                    options);

            //Check if an answer supplied and if not return
            if (psiIsSymetric.getPsiDataValue().equals(""))
                return ("");
            else
                szIsSmetric = psiIsSymetric.getPsiDataValue();
        }

        if (szIsSmetric.equalsIgnoreCase("Yes"))
            psiEncryptingKey = phiClass.retPsiData(phData, evalNode, "Encrypting", "The encrypting key of the marked EncryptedData seems to be agreed applicatively. Please specify the symetric encripting key of the marked of EncryptedData element.", true, null);
        else
            psiEncryptingKey = phiClass.retPsiData(phData, evalNode, "Encrypting", "The encrypting key of the marked EncryptedData seems to be agreed applicatively. Please specify the public key owner", false, null);

        szEncrypting = psiEncryptingKey.getPsiDataValue();

        //Check if a key supplied and if not return
        if (szEncrypting.equals(""))
            return ("");

        if (szIsSmetric.equalsIgnoreCase("No"))
            szEncrypting = "PK(" + szEncrypting + ")";

        return(szEncrypting);
    }

    //Reading the EncryptionMethod element to find out if the encrypting key is symetric or not
    //
    // Returns: yes if symetric key algorithm
    // Returns: no if asymetric key algorithm
    // Returns: "" if no recognized algorithm
    public static String evalEncryptionMethod(phiData phData, org.w3c.dom.Node EncryptionMethodNode){

        org.w3c.dom.Node AlogorithmNode;
        String szAlgorithmURI, szAlgorithmName;

        if (EncryptionMethodNode == null)
            return("");
        else {
            AlogorithmNode = EncryptionMethodNode.getAttributes().getNamedItem("Algorithm");

            if (AlogorithmNode == null)
                AlogorithmNode = EncryptionMethodNode.getAttributes().getNamedItemNS(phData.xmlEncURI, "Algorithm");

            szAlgorithmURI = AlogorithmNode.getNodeValue();

            int namePosition = szAlgorithmURI.indexOf("xmlenc#") + 7;

            szAlgorithmName = szAlgorithmURI.substring(namePosition);

            //Block Encryption
            if (szAlgorithmName.startsWith("tripledes") || szAlgorithmName.startsWith("aes") ){
                return("Yes");
            }
            //Key Transport
            else if (szAlgorithmName.startsWith("rsa") ){
                return("No");
            }
            //Symmetric Key Wrap
            else if (szAlgorithmName.startsWith("kw") ){
                return("Yes");
            }


        }

        return("");
    }


    //This EncryptedData does not have a context and it is signed
    //look whether there is DataReference pointing at this element
    //in the SOAP documet.
    private static boolean isPointedByDataReference(phiData phData, org.w3c.dom.Node evalNode) {
        org.w3c.dom.Node indexNode, attrNode, tempAttrNode;
        org.w3c.dom.NodeList list, list2;

        attrNode = evalNode.getAttributes().getNamedItemNS(phData.utilitySchemaURI,"Id");

        if (attrNode == null)
            attrNode = evalNode.getAttributes().getNamedItem("Id");

        if (attrNode != null) {

            //Look for an approperiate DataReference element in the document
            list = phData.document.getElementsByTagName("DataReference");
            list2 = phData.document.getElementsByTagNameNS(phData.xmlEncURI,"DataReference");

            for (int i = 0; i < (list.getLength() + list2.getLength()); i++) {
                if (i < list.getLength() )
                    indexNode = list.item(i);
                else
                    indexNode = list2.item(i - list.getLength());

                tempAttrNode = indexNode.getAttributes().getNamedItem("URI");

                if (tempAttrNode == null)
                    tempAttrNode = indexNode.getAttributes().getNamedItemNS(phData.xmlEncURI, "URI");

                if (tempAttrNode != null) {
                    if (tempAttrNode.getNodeValue().equals("#" + attrNode.getNodeValue()))
                        return(true);
                }
            }

        }

      return(false);
    }


}
