package phi;

import javax.swing.JOptionPane;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class KeyIdentifier {
    public KeyIdentifier() {
    }

    /***********************************************
   * phi of EncryptedKey with one arguement
   ************************************************/
    public static String eval(phiData phData, org.w3c.dom.Node evalNode) {
       return("");
   }


    /***********************************************
    * phi of EncryptedKey with two arguements
    ************************************************/
   public static String eval(phiData phData, org.w3c.dom.Node evalNode, String szArg) {

       String szAlgorithm, szResult = "", szIsSymmetric="", szKey="";
       org.w3c.dom.Node attrNode=null;

       attrNode = evalNode.getAttributes().getNamedItem("ValueType");

       if (attrNode == null)
           attrNode = evalNode.getAttributes().getNamedItemNS(phData.wssSchemaURI, "ValueType");

       if ( attrNode != null && !((szAlgorithm = getLocalValue(attrNode.getNodeValue())).equals("")) )
               szIsSymmetric = isSymmetric(szAlgorithm);

       if ( szIsSymmetric.equals("") )
           szIsSymmetric= getSymmetric(phData, evalNode);

       if (szIsSymmetric.equals("")) {
           phData.phiAborted = true;
           return ("");
       }


       if (!phData.bAbstracted) {

           szKey = checkKeyFromUser(phData, evalNode, szIsSymmetric, szArg);

           if (szKey.equals(""))
               return("");

       //Get the key from the SOAP message itself
       } else {
           szKey = evalNode.getFirstChild().getNodeValue().trim();

           //check the validity of the key
           if ( szIsSymmetric.equalsIgnoreCase("No") ){
               if ( !(szKey.startsWith("PK(")  && szKey.length() > 4 && szKey.endsWith(")")) ) {
                   JOptionPane.showMessageDialog(null,"KeyIdentifier: a public key is expected" ,"Abort" , JOptionPane.ERROR_MESSAGE);
                   phData.phiAborted = true;
                   return("");

               }
           }

           if ( szKey.startsWith("PK(")  && szKey.length() > 4 && szKey.endsWith(")") ) {
               if ( szIsSymmetric.equalsIgnoreCase("Yes") ){
                   JOptionPane.showMessageDialog(null,"KeyIdentifier: Inconsistency between the ValueType and the key" ,"Abort" , JOptionPane.ERROR_MESSAGE);
                   phData.phiAborted = true;
                   return("");
               }
           }  else {
               if ( szIsSymmetric.equalsIgnoreCase("No") ){
                   JOptionPane.showMessageDialog(null,"KeyIdentifier: Inconsistency between the ValueType and the key" ,"Abort" , JOptionPane.ERROR_MESSAGE);
                   phData.phiAborted = true;
                   return("");
               }
           }

           if ( szIsSymmetric.equalsIgnoreCase("Yes") )
              phiClass.saveAbstractedPsiData(phData, evalNode, szKey, "Key", true);
           else {
               String szValue = szKey.substring(3, szKey.lastIndexOf(')') );

               phiClass.saveAbstractedPsiData(phData, evalNode, szValue, "Key", false);
           }

       }


       if ( szIsSymmetric.equalsIgnoreCase("No") && szArg.equals("SIG"))
           szResult = "SK(" + szKey.substring(3,szKey.lastIndexOf(')')) + ")";
       else if ( szIsSymmetric.equalsIgnoreCase("Yes") && szArg.equals("SIGNATURE"))
           szResult = "R(" + szKey + ")";
       else
           szResult = szKey;


       return (szResult);
 }


   private static String getLocalValue(String szValue){
       int nPosition = szValue.indexOf(':');

       if (nPosition >= 0)
           return (szValue.substring(nPosition + 1));
       else
           return(szValue);
   }


   private static String isSymmetric(String szAlgorithm) {

       if ( szAlgorithm.equalsIgnoreCase("X509v3") ){
           return("No");
       }

       return("");
   }



   private static String getSymmetric(phiData phData, org.w3c.dom.Node evalNode){

      String[] options = {"Yes", "No"};
      psiData psiIsSymetric;

      psiIsSymetric = phiClass.retPsiData(
            phData,
            evalNode,
            "Symetric",
            "Is the key in the marked KeyIdentifier a Symmetric key (yes/no)",
            false,
            options);

      //Check if an answer supplied and if not return
      if (psiIsSymetric.getPsiDataValue().equals(""))
          return ("");
      else
          return(psiIsSymetric.getPsiDataValue());

   }

   private static String checkKeyFromUser(phiData phData,
                                          org.w3c.dom.Node evalNode,
                                          String szIsSymmetric,
                                          String szArg){

       String szKey;
       psiData psiKey;

       if (szIsSymmetric.equalsIgnoreCase("Yes"))
           psiKey = phiClass.retPsiData(phData, evalNode, "Key", "Please specify the key enclosed in the marked KeyIdentifier element", true, null);
       else
           psiKey = phiClass.retPsiData(phData, evalNode, "Key", "Please specify the public key owner of the key enclosed in the marked KeyIdentifier element", false, null);

       szKey = psiKey.getPsiDataValue();

       //Check if a key supplied and if not return
       if (szKey.equals(""))
           return ("");

       if (szIsSymmetric.equalsIgnoreCase("No"))
               szKey = "PK(" + szKey + ")";


       return(szKey);

   }
}
