package phi;

import javax.swing.JOptionPane;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
/*
 suelements

      - KeyName -> minOccur = 0
      - KeyValue -> minOccur = 0
      - RetrivalMethod -> minOccur = 0
      - X509Data -> minOccur = 0
      - PGPData -> minOccur = 0
      - SPKIData -> minOccur = 0
      - MgmtData -> minOccur = 0
and by the XML Encryption specificatoin
      - EncryptedKey -> minOccur = 0

 by the WSS specification
      -SecurityTokenReference

 */
public class KeyInfo {
    public KeyInfo() {
    }

    /***********************************************
   * phi of KeyInfo with one arguement
   ************************************************/
    public static String eval(phiData phData, org.w3c.dom.Node evalNode) {
        org.w3c.dom.Node indexNode, RetrivalMethodNode=null;
        org.w3c.dom.NodeList list;
        String szIsSmetric, szResult= "";
        int nSubElementsNumber = 0;

        list = evalNode.getChildNodes();

        // Loop through the list.
        for (int i=0; i < list.getLength(); i++) {
            indexNode = list.item(i);
            if (indexNode.getNodeType() == indexNode.ELEMENT_NODE) {
                if ( indexNode.getLocalName().equals("RetrivalMethod") )
                  RetrivalMethodNode = indexNode;
              else {
                  szResult = szResult.concat(phiClass.evaluateNode(phData, indexNode));
                  nSubElementsNumber++;
              }

            }
        }

        if (nSubElementsNumber > 1 ) {
            JOptionPane.showMessageDialog(null,"phi does not support KeyInfo with more than one key" ,"Abort" , JOptionPane.ERROR_MESSAGE);
                phData.phiAborted = true;
                return("");
        }


        szIsSmetric = evalRetrivalMethod(phData, RetrivalMethodNode);

        if ( szResult.equals("") || szIsSmetric.equals("") )
            return(szResult);

        //Check for inconsistency between RetrivalMethod and the key
        if ( szIsSmetric.equalsIgnoreCase("Yes") ) {
            if ( szResult.startsWith("PK(") || szResult.startsWith("SK(") ) {
                JOptionPane.showMessageDialog(null,
                        "KeyInfo: RetrivalMethod does not correspond key",
                                              "Abort",
                                              JOptionPane.ERROR_MESSAGE);
                phData.phiAborted = true;
                return ("");
            }
        } else {
            if (!(szResult.startsWith("PK(") || szResult.startsWith("SK("))) {
                JOptionPane.showMessageDialog(null,
                                              "KeyInfo: RetrivalMethod does not correspond key",
                                              "Abort",
                                              JOptionPane.ERROR_MESSAGE);
                phData.phiAborted = true;
                return ("");

            }
        }


        return(szResult);

    }


    /***********************************************
     * phi of KeyInfo with two arguements
     ************************************************/
    public static String eval(phiData phData, org.w3c.dom.Node evalNode, String szArg) {
      org.w3c.dom.Node indexNode, RetrivalMethodNode=null;
      org.w3c.dom.NodeList list;
      String szIsSmetric, szResult= "";
      int nSubElementsNumber = 0;

      list = evalNode.getChildNodes();

      // Loop through the list.
      for (int i=0; i < list.getLength(); i++) {
          indexNode = list.item(i);
          if (indexNode.getNodeType() == indexNode.ELEMENT_NODE)
              if ( indexNode.getLocalName().equals("RetrivalMethod") )
                  RetrivalMethodNode = indexNode;
              else {
                  szResult = szResult.concat(phiClass.evaluateNode(phData, indexNode, szArg));
                  nSubElementsNumber++;
              }
      }

      if (nSubElementsNumber > 1 ) {
          JOptionPane.showMessageDialog(null,"phi does not support KeyInfo with more than one key" ,"Abort" , JOptionPane.ERROR_MESSAGE);
          phData.phiAborted = true;
          return("");
      }


      if ( szResult.equals("") && !phData.phiAborted)
          if ( !phData.bAbstracted )
              szResult = getKeyInfo(phData, evalNode, RetrivalMethodNode);
          else {
              JOptionPane.showMessageDialog(null,"Key could not be retrive in KeyInfo" ,"Abort" , JOptionPane.ERROR_MESSAGE);
              phData.phiAborted = true;
              return("");
          }


      szIsSmetric = evalRetrivalMethod(phData, RetrivalMethodNode);

      if ( szResult.equals("") || szIsSmetric.equals("") )
          return(szResult);


      //Check for inconsistency between RetrivalMethod and the key
      if ( szIsSmetric.equalsIgnoreCase("Yes") ) {
          if ( szResult.startsWith("PK(") || szResult.startsWith("SK(") ) {
              JOptionPane.showMessageDialog(null,
                                            "KeyInfo: RetrivalMethod does not correspond key",
                                            "Abort",
                                            JOptionPane.ERROR_MESSAGE);
              phData.phiAborted = true;
              return ("");
          }
      } else {
          if (!(szResult.startsWith("PK(") || szResult.startsWith("SK("))) {
              JOptionPane.showMessageDialog(null,
                                            "KeyInfo: RetrivalMethod does not correspond key",
                                            "Abort",
                                            JOptionPane.ERROR_MESSAGE);
              phData.phiAborted = true;
              return ("");

          }
      }

      return(szResult);

  }







  public static String getKeyInfo(phiData phData,
                                      org.w3c.dom.Node evalNode,
                                      org.w3c.dom.Node RetrivalMethodNode) {
       String szKey="", szIsSmetric;
       String[] options = {"Yes", "No"};
       psiData psiEncryptedKey, psiIsSymetric;

       szIsSmetric = evalRetrivalMethod(phData, RetrivalMethodNode);

       if ( szIsSmetric.equals("") ) {
          psiIsSymetric = phiClass.retPsiData(
          phData,
          evalNode,
          "Symetric",
          "Is the key reference by the marked KeyInfo Symetric (yes/no)",
          false,
          options);

          //Check if an answer supplied and if not return
          if (psiIsSymetric.getPsiDataValue().equals(""))
              return ("");
          else
              szIsSmetric = psiIsSymetric.getPsiDataValue();
        }

        if (szIsSmetric.equalsIgnoreCase("Yes"))
            psiEncryptedKey = phiClass.retPsiData(phData, evalNode, "Encrypting", "Please specify the symetric key referenced by the marked KeyInfo element.", true, null);
        else
            psiEncryptedKey = phiClass.retPsiData(phData, evalNode, "Encrypting", "Please specify the Asymetric key referenced by the marked KeyInfo element.", false, null);

        szKey = psiEncryptedKey.getPsiDataValue();

        //Check if a key supplied and if not return
        if (szKey.equals(""))
            return ("");

        if (szIsSmetric.equals("NO"))
            szKey = "PK(" + szKey + ")";

        return(szKey);
    }

    //Reading the RetrivalMethod element to find out if the key is symetric or not
    //
    // Returns: yes if symetric key algorithm
    // Returns: no if asymetric key algorithm
    // Returns: "" if no recognized algorithm
    public static String evalRetrivalMethod(phiData phData, org.w3c.dom.Node RetrivalMethodNode){

       org.w3c.dom.Node AlogorithmNode;
       String szAlgorithmURI, szAlgorithmName;

       if (RetrivalMethodNode == null)
           return("");
       else {
           AlogorithmNode = RetrivalMethodNode.getAttributes().getNamedItem("Algorithm");

           if (AlogorithmNode == null)
               AlogorithmNode = RetrivalMethodNode.getAttributes().getNamedItemNS(phData.xmlSigURI, "Type");

           szAlgorithmURI = AlogorithmNode.getNodeValue();

           int namePosition = szAlgorithmURI.indexOf("xmlsig#") + 7;

           szAlgorithmName = szAlgorithmURI.substring(namePosition);


           if (szAlgorithmName.startsWith("DSA") || szAlgorithmName.startsWith("RSA") ){
               return("No");
           }

           if (szAlgorithmName.startsWith("X509") || szAlgorithmName.startsWith("PGP") ){
               return("No");
           }

           else if (szAlgorithmName.startsWith("SPKI") ){
               return("No");
           }


       }

       return("");
   }


}
