package phi;

import javax.swing.JOptionPane;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class KeyName {
    public KeyName() {
    }

    /***********************************************
     * phi of EncryptedKey with one arguement
     ************************************************/
    public static String eval(phiData phData, org.w3c.dom.Node evalNode) {
        return("");
    }


    /***********************************************
     * phi of EncryptedKey with two arguements
     ************************************************/
    public static String eval(phiData phData, org.w3c.dom.Node evalNode, String szArg) {

        boolean bSymmetric;
        String szKeyName="", szKey;
        CarriedKeyNames carriedKeyNames;
        psiData psiKey=null;

        szKeyName = evalNode.getFirstChild().getNodeValue();

        if ( szKeyName.equals("") ){
            JOptionPane.showMessageDialog(null,
                                "KeyName: No value supplied!", "Abort",
                                JOptionPane.ERROR_MESSAGE);
            phData.phiAborted = true;
            return ("");
        }

        //Check whether we know the key this name refers to
        carriedKeyNames = phData.phiRetKeyName(szKeyName);


        if ( carriedKeyNames == null) {
          //we are not familar with the name, ask the user which key this
          //name refers to
          psiKey = getKeyFromUser(phData, evalNode);

          if (psiKey == null)
              return("");

          bSymmetric = psiKey.isPsiDataSymetricKey();
          szKey = psiKey.getPsiDataValue();

          phData.phiSaveKeyName(szKeyName, szKey, bSymmetric);

        } else {
          // we know which key this name referes to
          bSymmetric = carriedKeyNames.isCarriedNameSymmetric();
          szKey = carriedKeyNames.getCarriedNameValue();
          if ( bSymmetric )
              phiClass.saveAbstractedPsiData(phData, evalNode, szKey, "Key", true);
           else
              phiClass.saveAbstractedPsiData(phData, evalNode, szKey, "Key", false);

        }

        if ( bSymmetric )
            return(szKey);
        else {
            if ( szArg.equals("SIG") )
               return ("SK(" + szKey + ")");
            else
               return ("PK(" + szKey + ")");
        }
    }



    private static psiData getKeyFromUser(phiData phData, org.w3c.dom.Node evalNode){

        psiData psiKey, psiIsSymetric;
        String[] options = {"Yes", "No"};

        //Check whether it is a symmetric key
        psiIsSymetric = phiClass.retPsiData(
                    phData,
                    evalNode,
                    "Symetric",
                    "It the key referenced by the marked Key Name symmetric (yes/no)",
                    false,
                    options);

        //Check if an answer supplied and if not return
        if (psiIsSymetric.getPsiDataValue().equals(""))
            return (null);

        if (psiIsSymetric.getPsiDataValue().equalsIgnoreCase("Yes"))
            psiKey = phiClass.retPsiData(phData,
                                         evalNode,
                                         "Key",
                                         "Please specify the symetric key associated with the marked name.",
                                         true,
                                         null);
        else
            psiKey = phiClass.retPsiData(phData,
                                         evalNode,
                                         "Key",
                                         "Please specify the owner of the public key associated with the marked name.",
                                         false,
                                         null);

        //Check if a key supplied and if not return
        if (psiKey.getPsiDataValue().equals(""))
            return (null);

        return(psiKey);


    }

}
