package phi;


/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class phiClass {

    final static String[] atoms = { "Body", "AbstrctedBody" };

    public phiClass() {

    }


    public static String applyPhi(phiData phData){

      //change '<' and '>' for html presantation
      phData.setSOAPFileData(phData.getSOAPFileData().replaceAll("<","&lt;"));
      phData.setSOAPFileData(phData.getSOAPFileData().replaceAll(">","&gt;"));

      return Envelope.eval(phData, phData.document.getDocumentElement());
    }


    public static String evaluateNode(phiData phData, org.w3c.dom.Node evalNode){

        if (phData.phiAborted)
            return("");


        if (evalNode.getLocalName().equals("Envelope")) {
            return (Envelope.eval(phData, evalNode));
        } else if (evalNode.getLocalName().equals("Header")) {
            return (Header.eval(phData, evalNode));
        } else if (evalNode.getLocalName().equals("Body")) {
            return (Body.eval(phData, evalNode));
        } else if (evalNode.getLocalName().equals("Security")) {
            return (Security.eval(phData, evalNode));
        } else if (evalNode.getLocalName().equals("Signature")) {
            return (Signature.eval(phData, evalNode));
        } else if (evalNode.getLocalName().equals("EncryptedData")) {
            return (EncryptedData.eval(phData, evalNode));
        } else if (evalNode.getLocalName().equals("SignedInfo")) {
             return (SignedInfo.eval(phData, evalNode));
        } else if (evalNode.getLocalName().equals("EncryptedKey")) {
            return (EncryptedKey.eval(phData, evalNode));
        } else if (evalNode.getLocalName().equals("KeyInfo")) {
            return (KeyInfo.eval(phData, evalNode));
        } else if (evalNode.getLocalName().equals("BinarySecurityToken")) {
            return (BinarySecurityToken.eval(phData, evalNode));
        } else if (evalNode.getLocalName().equals("KeyName")) {
            return (KeyName.eval(phData, evalNode));
        } else if (evalNode.getLocalName().equals("ReferenceList")) {
           return (ReferenceList.eval(phData, evalNode));
        } else if (evalNode.getLocalName().equals("SecurityTokenReference")) {
          return (SecurityTokenReference.eval(phData, evalNode));
        } else if (evalNode.getLocalName().equals("Reference")) {
          return (Reference.eval(phData, evalNode));
        } else if (evalNode.getLocalName().equals("KeyIdentifier")) {
          return (KeyIdentifier.eval(phData, evalNode));
        } else if (evalNode.getLocalName().equals("DataReference")) {
           return (DataReference.eval(phData, evalNode));
        } else if (evalNode.getLocalName().equals("KeyReference")) {
          return (KeyReference.eval(phData, evalNode));
        } else if (evalNode.getLocalName().equals("CipherData")) {
          return (CipherData.eval(phData, evalNode));
        } else if (evalNode.getLocalName().equals("Embedded")) {
          return (Embedded.eval(phData, evalNode));
        } else if (evalNode.getLocalName().equals("X509Data") ||
                   evalNode.getLocalName().equals("PGPData")  ||
                   evalNode.getLocalName().equals("SPKIData")) {
          return (PublicKeyReferences.eval(phData, evalNode));
        } else {
            return ("phiClass: " + evalNode.getLocalName() +
                    " is not implemented by phi");
        }
    }

    public static String evaluateNode(phiData phData, org.w3c.dom.Node evalNode, String szArg){

       if (phData.phiAborted)
           return("");

       if (evalNode.getLocalName().equals("Envelope")) {
           return (Envelope.eval(phData, evalNode, szArg));
       } else if (evalNode.getLocalName().equals("Header")) {
           return (Header.eval(phData, evalNode, szArg));
       } else if (evalNode.getLocalName().equals("Body")) {
           return (Body.eval(phData, evalNode, szArg));
       } else if (evalNode.getLocalName().equals("Security")) {
           return (Security.eval(phData, evalNode, szArg));
       } else if (evalNode.getLocalName().equals("Signature")) {
            return (Signature.eval(phData, evalNode, szArg));
       } else if (evalNode.getLocalName().equals("EncryptedData")) {
             return (EncryptedData.eval(phData, evalNode, szArg));
       } else if (evalNode.getLocalName().equals("SignedInfo")) {
             return (SignedInfo.eval(phData, evalNode, szArg));
       } else if (evalNode.getLocalName().equals("EncryptedKey")) {
           return (EncryptedKey.eval(phData, evalNode, szArg));
       } else if (evalNode.getLocalName().equals("KeyInfo")) {
           return (KeyInfo.eval(phData, evalNode, szArg));
       } else if (evalNode.getLocalName().equals("BinarySecurityToken")) {
            return (BinarySecurityToken.eval(phData, evalNode, szArg));
       } else if (evalNode.getLocalName().equals("KeyName")) {
           return (KeyName.eval(phData, evalNode, szArg));
       } else if (evalNode.getLocalName().equals("ReferenceList")) {
           return (ReferenceList.eval(phData, evalNode, szArg));
       } else if (evalNode.getLocalName().equals("SecurityTokenReference")) {
          return (SecurityTokenReference.eval(phData, evalNode, szArg));
       } else if (evalNode.getLocalName().equals("Reference")) {
          return (Reference.eval(phData, evalNode, szArg));
       } else if (evalNode.getLocalName().equals("KeyIdentifier")) {
         return (KeyIdentifier.eval(phData, evalNode, szArg));
       } else if (evalNode.getLocalName().equals("DataReference")) {
           return (DataReference.eval(phData, evalNode, szArg));
       } else if (evalNode.getLocalName().equals("KeyReference")) {
           return (KeyReference.eval(phData, evalNode, szArg));
       } else if (evalNode.getLocalName().equals("CipherData")) {
           return (CipherData.eval(phData, evalNode, szArg));
       } else if (evalNode.getLocalName().equals("Embedded")) {
           return (Embedded.eval(phData, evalNode, szArg));
       } else if (evalNode.getLocalName().equals("X509Data") ||
                   evalNode.getLocalName().equals("PGPData")  ||
                   evalNode.getLocalName().equals("SPKIData")) {
          return (PublicKeyReferences.eval(phData, evalNode, szArg));
       } else {
           return ("phiClass: " + evalNode.getLocalName() +
                   " is not implemented by phi");
       }
   }

   //Get rid off the last comma
   public static String elementStrip(String szToStrip) {

    szToStrip = szToStrip.trim();

    if (szToStrip.equals(""))
       return(szToStrip);
    else if ( szToStrip.charAt(szToStrip.length() - 1) == ',' )
       return (szToStrip.substring(0, (szToStrip.length() - 1)));
    else
       return(szToStrip);
  }

  /*
   This function is used to retrive from the user the value abtracting
   bianry values when phi is run in bianry values mode
  */
  public static psiData retPsiData(
                             phiData phData,
                             org.w3c.dom.Node node,
                             String szIdentifier,
                             String szMessage,
                             boolean SymetricKey,
                             String[] options){

    psiData nodePsiData;

    //Check if this node was already proccessed
    nodePsiData = phData.phiRetPsiData(node, szIdentifier);

    if (nodePsiData.isPsiDataEmpty()){

        nodePsiData.setPsiDataNode(node);
        nodePsiData.setPsiDataValue(getValueOfPointing(phData,node,szMessage,options));
        nodePsiData.setPsiDataIdentifier(szIdentifier);
        nodePsiData.setPsiDataEmpty(false);
        nodePsiData.setPsiDataSymetricKey(SymetricKey);
        nodePsiData.setPsiDataAsymetricKey(!SymetricKey);


        phData.phiSavePsiData(nodePsiData);
    }

    return(nodePsiData);
  }


  /*
   This function is used to save psi value
   when phi is run in abstracted mode
  */
  public static psiData saveAbstractedPsiData(
                             phiData phData,
                             org.w3c.dom.Node node,
                             String szValue,
                             String szIdentifier,
                             boolean SymetricKey){

    psiData nodePsiData;

    //Check if this node was already proccessed
    //Unless this is a body element Since multipule bodies is allowed
    if ( !(node == null) )
        nodePsiData = phData.phiRetPsiData(node, szIdentifier);
    else
        nodePsiData = phData.phiRetPsiDataByValue(szIdentifier, szValue);

    //if the value is not saved yet, save it!
    if (nodePsiData.isPsiDataEmpty()){

        nodePsiData.setPsiDataNode(node);
        nodePsiData.setPsiDataValue(szValue);
        nodePsiData.setPsiDataIdentifier(szIdentifier);
        nodePsiData.setPsiDataEmpty(false);
        nodePsiData.setPsiDataSymetricKey(SymetricKey);
        nodePsiData.setPsiDataAsymetricKey(!SymetricKey);


        phData.phiSavePsiData(nodePsiData);
    }

    return(nodePsiData);
  }

  /*
    This function is used to ask the user how he wants to abstract a given node.

    phData   - the data structure
    node     - the node we want to get the abstraction
    szMessage - the message which asks the user to supply the abstraction
 */
  public static String getValueOfPointing(phiData phData,
                                          org.w3c.dom.Node node,
                                          String szMessage,
                                          String[] options){
      String szHtmlOutput = "";
      int nStartElement=0, nEndElement, nLocation, nCurrentLocation = 0;

      phData.nLocation = 0;
      nLocation = findNodeLocation(phData.document.getDocumentElement(), node, phData);

      //indexOf return -1 when the cannot find szNodeName in the
      //String
      while (nStartElement >= 0 && nCurrentLocation < nLocation) {
          nStartElement = phData.getSOAPFileData().indexOf(node.getNodeName(),nStartElement + 1);

          if (nStartElement < 0) {
              phData.phiAborted = true;
              System.out.println("findNodeLocation: cannot find element in specified location");
          }

          if (!phData.getSOAPFileData().substring(nStartElement - 1, nStartElement).equals("/")) {
              nCurrentLocation++;
          }
      }

      nEndElement = findEndElement(phData.getSOAPFileData(),node.getNodeName(), nStartElement);
      //end of the element cannot be found
      if ( nEndElement < 0 )
          nEndElement = phData.getSOAPFileData().indexOf("&gt;",nStartElement + 1) + 4;

      szHtmlOutput = "<html><head></head><body><pre>\n" +
                     phData.getSOAPFileData().substring(0, nStartElement - 5) +
                     "\n</pre>\n<div style='color:#ff0000;'><pre>\n" +
                     phData.getSOAPFileData().substring(nStartElement - 4,nEndElement) +
                     "</pre>\n</div>\n" +
                     "<pre>\n" +
                     phData.getSOAPFileData().substring(nEndElement + 1) +
                     "</pre></body></html>";


      //calling psidialog to get value from user
      psiDialog dlg = new psiDialog(phData,true, szMessage, szHtmlOutput, options);
      dlg.pack();
      dlg.show();

      //Check if the user supplied a value otherwise abort phi
      if (phData.psiResult == null || phData.psiResult.equals("")){
          phData.psiResult = "";
          phData.phiAborted = true;
      }
      return(phData.psiResult);

}



  public static int findEndElement(String szXML, String szNodeName, int nStartElement){
      int nEndElement, nSubElementsNum=0;


      nEndElement = szXML.indexOf(szNodeName,nStartElement+1);
      while (nEndElement >= 0) {

          if (szXML.charAt(nEndElement + szNodeName.length())== ' ' ||
              szXML.charAt(nEndElement + szNodeName.length())== '&' ) {

              if (szXML.substring(nEndElement - 1, nEndElement).equals("/")) {
                  if (nSubElementsNum == 0) {
                      return (szXML.indexOf("&gt;", nEndElement + 1) + 4);
                  } else {
                      nSubElementsNum--;
                  }
              } else {
                  nSubElementsNum++;
              }
          }
          nEndElement = szXML.indexOf(szNodeName,nEndElement+1);
      }

      return(nEndElement);
  }


  public static int findNodeLocation(org.w3c.dom.Node rootNode, org.w3c.dom.Node node, phiData phData){
      org.w3c.dom.Node indexNode;
      org.w3c.dom.NodeList list;
      int nRc;

      list = rootNode.getChildNodes();

      // Loop through the list.
      for (int i=0; i < list.getLength(); i++) {
          indexNode = list.item(i);
          if (indexNode.getNodeType() == indexNode.ELEMENT_NODE) {
              if (node.getNodeName().equals(indexNode.getNodeName()))
                  phData.nLocation++;
          }
          if (indexNode.equals(node))
                  return phData.nLocation;
          else {
              nRc = findNodeLocation(indexNode, node, phData);
              if (nRc > 0)
                  return(nRc);
          }
      }

      return(0);
  }

  public static org.w3c.dom.Node myGetElementById(phiData phData,
                                                     org.w3c.dom.Node rootNode,
                                                     String szId) {

     org.w3c.dom.Node indexNode, attrNode=null, tempNode;
     org.w3c.dom.NodeList list;

     if ( phData.bValidating )
         return(phData.document.getElementById(szId));

     list = rootNode.getChildNodes();

     // Loop through the list.
     for (int i=0; i < list.getLength(); i++) {
         indexNode = list.item(i);
         if (indexNode.getNodeType() == indexNode.ELEMENT_NODE) {
             attrNode = indexNode.getAttributes().getNamedItem("Id");

             if (attrNode == null)
                 attrNode = indexNode.getAttributes().getNamedItemNS(phData.utilitySchemaURI, "Id");

             if ( attrNode != null && attrNode.getNodeValue().equals(szId) )
                 return(indexNode);
             else {
                 tempNode = myGetElementById(phData, indexNode, szId);
                 if (tempNode != null)
                     return(tempNode);

             }
         }
     }

     return(null);
 }


 //returns true if the token is an Atom
 public static boolean isAtom(String szToken){

    for (int i=0; i < atoms.length; i++)
        if ( atoms[i].matches(szToken) )
            return(true);

    return(false);
 }


}
