package phi;

import java.awt.BorderLayout;
import java.awt.Frame;

import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JEditorPane;
import java.awt.*;
import javax.swing.JLabel;
import javax.swing.UIManager;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JScrollPane;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class psiDialog extends JDialog {
    JPanel panel1 = new JPanel();
    JEditorPane jEditorPane1 = new JEditorPane();
    JLabel jLabelError = new JLabel();
    JLabel jLabel2 = new JLabel();
    JTextField jTextField1 = new JTextField();
    JButton jButton1 = new JButton();
    JButton jButton2 = new JButton();
    GridBagLayout gridBagLayout1 = new GridBagLayout();
    phiData localPhi;
    String[] DialogOptions;

    public psiDialog(phiData phData, boolean modal, String azQuestion, String szHtml, String[] options) {
        super(phData.parent, "Binary data abstraction", modal);
        try {
            setDefaultCloseOperation(DISPOSE_ON_CLOSE);
            jbInit(phData, azQuestion,szHtml, options);
            pack();
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }

    public psiDialog() {
    }

    private void jbInit(phiData phData,String szQuestion, String szHtml, String[] options) throws Exception {
        localPhi = phData;
        localPhi.psiResult = null;
        DialogOptions = options;
        panel1.setLayout(gridBagLayout1);
//        jLabel1.setFont(new java.awt.Font("SansSerif", Font.BOLD, 16));
//        jLabel1.setForeground(UIManager.getColor("ComboBox.selectionBackground"));
//        jLabel1.setText("SOAP message");
        jLabelError.setFont(new java.awt.Font("SansSerif", Font.BOLD, 16));
        jLabelError.setForeground(Color.red);
        jLabelError.setText("");
        jLabel2.setText(szQuestion);
        jButton1.setText("OK");
        jButton1.addActionListener(new psiDialog_jButton1_actionAdapter(this));
        jButton2.setText("Cancel");
        jButton2.addActionListener(new psiDialog_jButton2_actionAdapter(this));
        jEditorPane1.setEditable(false);
        jEditorPane1.setContentType("text/html");
        JScrollPane scrollPane1SOAP = new JScrollPane(jEditorPane1);
        jEditorPane1.setText(szHtml);
        panel1.setPreferredSize(new Dimension(800, 700));
        getContentPane().add(panel1);
        panel1.add(scrollPane1SOAP, new GridBagConstraints(0, 0, 3, 1, 1.0, 1.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH,
                new Insets(16, 25, 0, 20), 0, 132));
        panel1.add(jLabelError, new GridBagConstraints(0, 1, 3, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(13, 82, 0, 67), 251, 31));
        panel1.add(jLabel2, new GridBagConstraints(0, 2, 3, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(13, 82, 0, 67), 251, 31));
        panel1.add(jButton1, new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE,
                new Insets(22, 142, 23, 0), 7, 1));
        panel1.add(jButton2, new GridBagConstraints(2, 4, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE,
                new Insets(21, 0, 23, 155), 2, 1));
        panel1.add(jTextField1, new GridBagConstraints(1, 3, 1, 1, 1.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
                new Insets(11, 0, 0, 0), 11, 1));

    }

    //Ok Button was pressed
    public void jButton1_actionPerformed(ActionEvent e) {
        //Check if the input is valid
        if (jTextField1.getText().equals(""))
            jLabelError.setText("Please input a value!");
        else if (!IsValidOptionsSelected(jTextField1.getText().trim(), DialogOptions)) {
            jLabelError.setText("Please input a valid value!");
        } else {
            localPhi.psiResult = jTextField1.getText();
            dispose();
        }
    }

    public void jButton2_actionPerformed(ActionEvent e) {
        dispose();
    }

    private boolean IsValidOptionsSelected(String szUserChoice,String[] options) {

        if ( options == null)
            return true;

        for (int i=0; i<options.length; i++)
            if (options[i].equalsIgnoreCase(szUserChoice) )
                return true;

        return false;
    }
}


class psiDialog_jButton2_actionAdapter implements ActionListener {
    private psiDialog adaptee;
    psiDialog_jButton2_actionAdapter(psiDialog adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButton2_actionPerformed(e);
    }
}


class psiDialog_jButton1_actionAdapter implements ActionListener {
    private psiDialog adaptee;
    psiDialog_jButton1_actionAdapter(psiDialog adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButton1_actionPerformed(e);
    }
}
