package sud;

import java.awt.Frame;

import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JLabel;
import java.awt.*;
import javax.swing.JComboBox;
import javax.swing.JTextField;
import javax.swing.JButton;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import com.borland.jbcl.layout.XYLayout;
import com.borland.jbcl.layout.*;
import casper.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class SUDApplyPhiDialog extends JDialog {
    JPanel panel1 = new JPanel();
    JLabel jTitle = new JLabel();
    JLabel jLabelSender = new JLabel();
    JLabel jLabelReceiver = new JLabel();
    JComboBox jComboBoxSender;
    JTextField jTextSender = new JTextField();
    JComboBox jComboBoxSenderType;
    JComboBox jComboBoxReceiver;
    JTextField jTextReceiver = new JTextField();
    JComboBox jComboBoxReceiverType;
    JButton jOk = new JButton();
    JButton jCancel = new JButton();
    JLabel jError = new JLabel();
    GridLayout gridLayout1 = new GridLayout();
    XYLayout xYLayout1 = new XYLayout();
    JLabel jLabelQuestion = new JLabel();
    JComboBox jCombMesseges = new JComboBox();
    SUDData mdData;
    JLabel jLabelMessageNumber = new JLabel();
    JTextField jTextMessageNumber = new JTextField();

    //parsers
    Protocol_description proDes;
    Free_variables freeVars;
    String[] participants=null;
    String[] MessagesNumbers=null;


    public SUDApplyPhiDialog(Frame owner, boolean modal, SUDData mdData, String szScript) {
        super(owner, "ApplyingPhi", modal);
        try {
            setDefaultCloseOperation(DISPOSE_ON_CLOSE);
            jbInit(mdData, szScript);
            pack();
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }

    private void jbInit(SUDData mdData, String szScript) throws Exception {
        panel1.setLayout(xYLayout1);
        this.mdData = mdData;
        setResizable(false);
        jTitle.setFont(new java.awt.Font("SansSerif", Font.PLAIN, 16));
        jTitle.setForeground(Color.blue);
        jTitle.setToolTipText("");
        jTitle.setText("Applying Phi");
        jLabelSender.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
        jLabelSender.setText("Sender");
        jLabelReceiver.setFont(new java.awt.Font("SansSerif", Font.PLAIN, 12));
        jLabelReceiver.setText("Receiver");

        jTextSender.setText("");
        jComboBoxSenderType = new JComboBox(mdData.Types);
        jComboBoxReceiverType = new JComboBox(mdData.Types);
        jTextReceiver.setText("");
        jOk.setText("Ok");
        jOk.addActionListener(new SUDApplyPhiDialog_jOk_actionAdapter(this));
        jCancel.setText("Cancel");
        jCancel.addActionListener(new SUDApplyPhiDialog_jCancel_actionAdapter(this));
        jError.setFont(new java.awt.Font("SansSerif", Font.BOLD, 14));
        jError.setForeground(Color.red);
        jError.setText("");

        //
        jComboBoxReceiverType.setEnabled(false);
        jComboBoxSenderType.setEnabled(false);
        jTextSender.setEnabled(false);
        jTextReceiver.setEnabled(false);
        jLabelQuestion.setText(
                "Place phi\'s result in Casper script after message");

        jLabelMessageNumber.setFont(new java.awt.Font("SansSerif", Font.PLAIN,11));
        jLabelMessageNumber.setText("What is the number of the new message?");
        jTextMessageNumber.setText("");



        //Create the CasperData structure for following parsing
        casperData csprData = new casperData();
        csprData.setScript(szScript);
        csprData.setTypes(mdData.Types);

        //parse protcol description for getting messeges numbers
        proDes = new Protocol_description(csprData);

        if ( !proDes.isLoaded() )
           jError.setText("Error parsing Protocol description section");
        else
            MessagesNumbers = proDes.getMessegesNumbers();

        if (MessagesNumbers != null) {
            jCombMesseges = new JComboBox(MessagesNumbers);
            jCombMesseges.setSelectedIndex(MessagesNumbers.length - 1);
        } else {
            jCombMesseges = new JComboBox();
            jCombMesseges.setEnabled(false);
        }

        //parse Free variable for getting the participants in the protocol
        freeVars = new Free_variables(csprData);

        if ( !freeVars.isLoaded() )
           jError.setText("Error parsing Free Variables section");
        else
            participants = freeVars.getParticipants();

        if ( participants != null ) {
            jComboBoxReceiver = new JComboBox(participants);
            jComboBoxSender = new JComboBox(participants);
            jComboBoxReceiver.setSelectedIndex(1);
            jComboBoxSender.addActionListener(new
                                              SUDApplyPhiDialog_jComboBoxSender_actionAdapter(this));
            jComboBoxReceiver.addActionListener(new
                                                SUDApplyPhiDialog_jComboBoxReceiver_actionAdapter(this));
        } else {
            jComboBoxReceiver = new JComboBox();
            jComboBoxSender = new JComboBox();
            jComboBoxReceiver.setEnabled(false);
            jComboBoxSender.setEnabled(false);
        }

        getContentPane().add(panel1);
        panel1.add(jTitle, new XYConstraints(23, 17, 149, 35));
        panel1.add(jError, new XYConstraints(25, 266, 345, 27));
        panel1.add(jLabelSender, new XYConstraints(63, 60, 70, 29));
        panel1.add(jLabelReceiver, new XYConstraints(220, 59, 83, 27));
        panel1.add(jComboBoxSender, new XYConstraints(52, 93, 61, -1));
        panel1.add(jComboBoxReceiver, new XYConstraints(217, 93, 61, -1));
        panel1.add(jComboBoxSenderType, new XYConstraints(100, 132, 61, -1));
        panel1.add(jComboBoxReceiverType, new XYConstraints(270, 132, 61, -1));
        panel1.add(jOk, new XYConstraints(97, 230, 62, 26));
        panel1.add(jCancel, new XYConstraints(205, 231, 67, 24));
        panel1.add(jLabelQuestion, new XYConstraints(20, 192, 239, 25));
        panel1.add(jLabelMessageNumber, new XYConstraints(19, 173, 236, 19));
        panel1.add(jCombMesseges, new XYConstraints(271, 197, 46, 15));
        panel1.add(jTextMessageNumber, new XYConstraints(271, 174, 47, 14));
        panel1.add(jTextSender, new XYConstraints(26, 132, 61, 20));
        panel1.add(jTextReceiver, new XYConstraints(194, 132, 61, 20));
    }

    public void jComboBoxSender_actionPerformed(ActionEvent e) {

        if ( jComboBoxSender.getSelectedItem().equals("Else") ) {
            jComboBoxSenderType.setEnabled(true);
            jTextSender.setEnabled(true);
        } else {
            jComboBoxSenderType.setEnabled(false);
            jTextSender.setEnabled(false);
        }

    }

    public void jComboBoxReceiver_actionPerformed(ActionEvent e) {

        if ( jComboBoxReceiver.getSelectedItem().equals("Else") ) {
            jComboBoxReceiverType.setEnabled(true);
            jTextReceiver.setEnabled(true);
        } else {
            jComboBoxReceiverType.setEnabled(false);
            jTextReceiver.setEnabled(false);
        }

    }

    public void jOk_actionPerformed(ActionEvent e) {
        String szSender="", szSenderType = "", szReceiver="", szReceiverType = "";
        String szMsgNum;

        jError.setText("");

        if ( !jComboBoxSender.isEnabled() ||
             !jComboBoxReceiver.isEnabled() ||
             !jCombMesseges.isEnabled() )
           jError.setText("Operation cannot be performed due to previous error!");

        if ( jError.getText().matches("") && jComboBoxSender.getSelectedItem().equals("Else") )
            if (jTextSender.getText().matches(""))
                jError.setText("All fields must be filled");
            else {
                szSender = jTextSender.getText().trim();

                if ( isDefined(szSender, participants) )
                   jError.setText(szSender + " is already defined");

                szSenderType = (String)jComboBoxSenderType.getSelectedItem();
            }
        else
            szSender = (String)jComboBoxSender.getSelectedItem();

        if ( jError.getText().matches("") && jComboBoxReceiver.getSelectedItem().equals("Else") )
            if (jTextReceiver.getText().matches(""))
                jError.setText("All fields must be filled");
            else {
                szReceiver = jTextReceiver.getText().trim();

                if ( isDefined(szReceiver, participants) )
                   jError.setText(szReceiver + " is already defined");
                szReceiverType = (String)jComboBoxReceiverType.getSelectedItem();
            }
        else
            szReceiver = (String)jComboBoxReceiver.getSelectedItem();

        if ( jError.getText().matches("") &&  szSender.matches(szReceiver) )
            jError.setText("Sender and Receiver must be set to different values");

        szMsgNum = jTextMessageNumber.getText();

        if ( jError.getText().matches("") && szMsgNum.matches("") )
            jError.setText("Message Number must be set");

        if ( jError.getText().matches("") &&
             (szMsgNum.indexOf('.') > -1 ||
             szMsgNum.indexOf('\\') > -1 ||
             szMsgNum.indexOf('#') > -1 ) )
           jError.setText("Message Number contains invalid character");

       if ( jError.getText().matches("") )
           if ( isDefined(szMsgNum, MessagesNumbers) )
                   jError.setText("Messege number " + szMsgNum + " is already defined");

       if ( jError.getText().matches("") ) {

           mdData.szSender = szSender;
           mdData.szSenderType = szSenderType;
           mdData.szReceiver = szReceiver;
           mdData.szReceiverType = szReceiverType;
           mdData.szMsgNum = szMsgNum;
           mdData.szAfterMsg = (String)jCombMesseges.getSelectedItem();
           mdData.bPhiDialogSuccess = true;

           dispose();
       }
    }

    public void jCancel_actionPerformed(ActionEvent e) {
        dispose();
    }

    private boolean isDefined(String szItem, String[] list){

        for (int i=0; i < list.length; i++) {
            if ( list[i].matches(szItem) )
                return(true);
        }

        return(false);
    }
}


class SUDApplyPhiDialog_jCancel_actionAdapter implements ActionListener {
    private SUDApplyPhiDialog adaptee;
    SUDApplyPhiDialog_jCancel_actionAdapter(SUDApplyPhiDialog adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jCancel_actionPerformed(e);
    }
}


class SUDApplyPhiDialog_jOk_actionAdapter implements ActionListener {
    private SUDApplyPhiDialog adaptee;
    SUDApplyPhiDialog_jOk_actionAdapter(SUDApplyPhiDialog adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jOk_actionPerformed(e);
    }
}


class SUDApplyPhiDialog_jComboBoxReceiver_actionAdapter implements ActionListener {
    private SUDApplyPhiDialog adaptee;
    SUDApplyPhiDialog_jComboBoxReceiver_actionAdapter(SUDApplyPhiDialog adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jComboBoxReceiver_actionPerformed(e);
    }
}


class SUDApplyPhiDialog_jComboBoxSender_actionAdapter implements ActionListener {
    private SUDApplyPhiDialog adaptee;
    SUDApplyPhiDialog_jComboBoxSender_actionAdapter(SUDApplyPhiDialog adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jComboBoxSender_actionPerformed(e);
    }
}
