package sud;

import java.awt.*;
import java.awt.event.*;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JToolBar;
import javax.swing.JButton;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.*;
import javax.swing.border.TitledBorder;
import java.io.IOException;
import java.io.FileWriter;
import java.io.File;
import java.io.FileReader;
import phi.*;
import casper.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class SUDFrame extends JFrame {

    //Data structures
    SUDData mdData = new SUDData();
    phiData phData = null;

    //Initialization vars
    public SUDClass_EnvInit initTask=null;


    JPanel contentPane;
    BorderLayout borderLayout1 = new BorderLayout();
    JMenuBar jMenuBar1 = new JMenuBar();
    JMenu jMenuFile = new JMenu();
    JMenuItem jMenuFileExit = new JMenuItem();
    JMenuItem jMenuFileNew = new JMenuItem();
    JMenuItem jMenuFileInitialize = new JMenuItem();
    JMenu jMenuEdit = new JMenu();
    JMenuItem jMenuFontChooser = new JMenuItem();
    JMenuItem jMenuEditForeGroundColor = new JMenuItem();
    JMenuItem jMenuEditBackGroundColor = new JMenuItem();
    JMenu jMenuLogs = new JMenu();
    JMenuItem jMenuLogsParser = new JMenuItem();
    JMenu jMenuConfiguration = new JMenu();
    JMenuItem jMenuConfigurationParser = new JMenuItem();
    JMenuItem jMenuLogsInitialization = new JMenuItem();
    JMenu jMenuHelp = new JMenu();
    JMenuItem jMenuHelpAbout = new JMenuItem();
    JToolBar jToolBar = new JToolBar();
    JButton jButton1 = new JButton();
    JButton jButton2 = new JButton();
    JButton jButton3 = new JButton();
    ImageIcon image1 = new ImageIcon(sud.SUDFrame.class.getResource(
            "openFile.png"));
    ImageIcon image2 = new ImageIcon(sud.SUDFrame.class.getResource(
            "closeFile.png"));
    ImageIcon image3 = new ImageIcon(sud.SUDFrame.class.getResource("help.png"));
    JPanel jPanel1 = new JPanel();
    JTextArea jSOAPArea = new JTextArea();
//  JEditorPane jSOAPArea = new JEditorPane();
    TitledBorder titledBorder1 = new TitledBorder("");
    JTextArea jCasperArea = new JTextArea();
//  JEditorPane jCasperArea = new JEditorPane();
    JButton jButtonLoadSOAP = new JButton();
    JButton jButtonApplyPhi = new JButton();
    JLabel jLabel1 = new JLabel();
    JLabel jLabel2 = new JLabel();
    GridBagLayout gridBagLayout1 = new GridBagLayout();
    JButton jButtonSaveScript = new JButton();
    JButton jButtonSaveAsScript = new JButton();
    JButton jButtonAnalyseScript = new JButton();
    JFileChooser jFileChooser1 = new JFileChooser();
    JLabel statusBar = new JLabel();


    public SUDFrame() {
        try {
            setDefaultCloseOperation(EXIT_ON_CLOSE);
            jbInit();
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }

    /**
     * Component initialization.
     *
     * @throws java.lang.Exception
     */
    private void jbInit() throws Exception {
        contentPane = (JPanel) getContentPane();
        contentPane.setLayout(borderLayout1);
//        setSize(new Dimension(400, 300));
        setExtendedState(JFrame.MAXIMIZED_BOTH);
        setTitle("SUD: SOAP under Dolev-Yao");
        jMenuFile.setText("File");
        jMenuEdit.setText("Edit");
        jMenuLogs.setText("Logs");
        jMenuConfiguration.setText("Configuration");
        jMenuFileExit.setText("Exit");
        jMenuFileNew.setText("New Protocol");
        jMenuFileInitialize.setText("Reinitialize");
        jMenuFontChooser.setText("Font");
        jMenuEditForeGroundColor.setText("Foreground Color");
        jMenuEditBackGroundColor.setText("Background Color");
        jMenuLogsInitialization.setText("Initialization Log");
        jMenuLogsParser.setText("Parser Log");
        jMenuConfigurationParser.setText("Parser");
        jMenuFileExit.addActionListener(new
                                        SUDFrame_jMenuFileExit_ActionAdapter(this));
        jMenuFileNew.addActionListener(new
                                        SUDFrame_jMenuFileNew_ActionAdapter(this));
        jMenuFileInitialize.addActionListener(new
                                        SUDFrame_jMenuFileInitialize_ActionAdapter(this));

        jMenuFontChooser.addActionListener(new
                                        SUDFrame_jMenuFontChooser_ActionAdapter(this));

        jMenuEditForeGroundColor.addActionListener(new
                                        SUDFrame_jMenuEditColor_ActionAdapter(this));
        jMenuEditBackGroundColor.addActionListener(new
                                        SUDFrame_jMenuEditColor_ActionAdapter(this));

        jMenuLogsInitialization.addActionListener(new
                                        SUDFrame_jMenuLogs_ActionAdapter(this));
        jMenuLogsParser.addActionListener(new
                                        SUDFrame_jMenuLogs_ActionAdapter(this));

        jMenuConfigurationParser.addActionListener(new
                                        SUDFrame_jMenuConfiguration_ActionAdapter(this));
        jMenuHelp.setText("Help");
        jMenuHelpAbout.setText("About");
        jMenuHelpAbout.addActionListener(new
                                         SUDFrame_jMenuHelpAbout_ActionAdapter(this));
        jPanel1.setBorder(BorderFactory.createLineBorder(Color.black));
        jPanel1.setInputVerifier(null);
        jPanel1.setLayout(gridBagLayout1);
        jSOAPArea.setBorder(BorderFactory.createLineBorder(Color.black));
        jSOAPArea.setText("");
        jSOAPArea.setEditable(false);
        JScrollPane scrollPane1SOAP = new JScrollPane(jSOAPArea);
        jCasperArea.setBorder(BorderFactory.createLineBorder(Color.black));
        jCasperArea.setText("");
        JScrollPane scrollPane1Casper = new JScrollPane(jCasperArea);
        jButtonLoadSOAP.setText("Load");
        jButtonApplyPhi.setText("ApplyPhi");
        jButtonApplyPhi.addActionListener(new
                SUDFrame_jButtonApplyPhi_actionAdapter(this));
        jButtonLoadSOAP.addActionListener(new
                                         SUDFrame_jButtonLoadSOAP_actionAdapter(this));
        jLabel1.setFont(new java.awt.Font("SansSerif", Font.BOLD, 16));
        jLabel1.setForeground(Color.blue);
        jLabel1.setText("SOAP Message");
        jLabel2.setFont(new java.awt.Font("SansSerif", Font.BOLD, 16));
        jLabel2.setForeground(Color.blue);
        jLabel2.setText("Casper Input");
        jButtonSaveScript.setText("Save");
        jButtonSaveScript.addActionListener(new
                SUDFrame_jButtonSaveScript_actionAdapter(this));
        jButtonSaveAsScript.setText("SaveAs");
        jButtonSaveAsScript.addActionListener(new
                SUDFrame_jButtonSaveAsScript_actionAdapter(this));
        jButtonAnalyseScript.setText("Analyse");
        jMenuBar1.add(jMenuFile);
        jMenuFile.add(jMenuFileNew);
        jMenuFile.add(jMenuFileInitialize);
        jMenuFile.add(jMenuFileExit);
        jMenuBar1.add(jMenuEdit);
        jMenuEdit.add(jMenuFontChooser);
        jMenuEdit.add(jMenuEditForeGroundColor);
        jMenuEdit.add(jMenuEditBackGroundColor);
        jMenuBar1.add(jMenuConfiguration);
        jMenuConfiguration.add(jMenuConfigurationParser);
        jMenuBar1.add(jMenuLogs);
        jMenuLogs.add(jMenuLogsInitialization);
        jMenuLogs.add(jMenuLogsParser);
        jMenuBar1.add(jMenuHelp);
        jMenuHelp.add(jMenuHelpAbout);
        setJMenuBar(jMenuBar1);
        jButton1.setIcon(image1);
        jButton1.setToolTipText("Open File");
        jButton2.setIcon(image2);
        jButton2.setToolTipText("Close File");
        jButton3.setIcon(image3);
        jButton3.setToolTipText("Help");
        jToolBar.add(jButton1);
        jToolBar.add(jButton2);
        jToolBar.add(jButton3);
        statusBar.setText(" ");
        contentPane.add(jToolBar, BorderLayout.NORTH);
        contentPane.add(statusBar, BorderLayout.SOUTH);
        contentPane.add(jPanel1, java.awt.BorderLayout.CENTER);
        jPanel1.add(scrollPane1Casper, new GridBagConstraints(1, 1, 1, 1, 1.0, 1.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH,
                new Insets(0, 9, 0, 8), 100, 192));
        jPanel1.add(scrollPane1SOAP, new GridBagConstraints(0, 1, 1, 1, 1.0, 1.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH,
                new Insets(0, 7, 0, 0), 130, 192));
        jPanel1.add(jLabel1, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(2, 30, 0, 57), 5, 0));
        jPanel1.add(jLabel2, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(2, 25, 0, 35), 31, 4));
        jPanel1.add(jButtonLoadSOAP, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE,
                new Insets(0, 0, 0, 70), 0, 0));
        jPanel1.add(jButtonApplyPhi, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE,
                new Insets(0, 70, 0, 0), 0, 0));
        jPanel1.add(jButtonSaveScript, new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE,
                new Insets(0, 0, 0, 120), 0, 0));
        jPanel1.add(jButtonSaveAsScript, new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE,
                new Insets(0, 15, 0, 0), 0, 0));

        jPanel1.add(jButtonAnalyseScript, new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE,
                new Insets(0, 165, 0, 0), 0, 0));


        /*
         *
         *   Prepare Initializatin
         *
        */
       initialize();

       setConfiguration();


    }

    /**
     * File | New Protocol action performed.
     *
     * @param actionEvent ActionEvent jMenuFileInitialize
     */
    void jMenuFileNew_actionPerformed(ActionEvent actionEvent) {
        if (okToAbandon(true)) {
            mdData.bLoadCancelled = false;
            SUDFrame_NewProtocol dlg = new SUDFrame_NewProtocol(this, mdData);
            Dimension dlgSize = dlg.getPreferredSize();
            Dimension frmSize = getSize();
            Point loc = getLocation();
            dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x,
                            (frmSize.height - dlgSize.height) / 2 + loc.y);
            dlg.setModal(true);
            dlg.pack();
            dlg.show();
            if ( !mdData.bLoadCancelled ) {
                jSOAPArea.setText("");
                jCasperArea.setText("");
                statusBar.setText("New Protocol environment initialized");
                phData = null;
                mdData.dirtyCasper = true;
                mdData.szCasperFileName = null;
                mdData.EnvirExists = true;
                mdData.CarriedNamesSet.clear();
                casperData csprData = new casperData();
                csprData.setInitiator(mdData.Initator, mdData.szInitatorType);
                csprData.setResponder(mdData.Responder, mdData.szResponderType);
                jCasperArea.setText(casperClass.InitScript(csprData));
            }
        }
    }

    /**
     * File | Initialize action performed.
     *
     * @param actionEvent ActionEvent
     */
    void jMenuFileInitialize_actionPerformed(ActionEvent actionEvent) {
        initialize();

        setConfiguration();

    }



    /**
     * File | Exit action performed.
     *
     * @param actionEvent ActionEvent
     */
    void jMenuFileExit_actionPerformed(ActionEvent actionEvent) {
        if (okToAbandon(true)) {
            System.exit(0);
        }
    }

    /**
     * Help | About action performed.
     *
     * @param actionEvent ActionEvent
     */
    void jMenuHelpAbout_actionPerformed(ActionEvent actionEvent) {
        SUDFrame_AboutBox dlg = new SUDFrame_AboutBox(this);
        Dimension dlgSize = dlg.getPreferredSize();
        Dimension frmSize = getSize();
        Point loc = getLocation();
        dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x,
                        (frmSize.height - dlgSize.height) / 2 + loc.y);
        dlg.setModal(true);
        dlg.pack();
        dlg.show();
    }


    /**
     * Save Casper Script button action performed.
     *
     * @param actionEvent ActionEvent
     */

    public void jButtonSaveScript_actionPerformed(ActionEvent e) {
        saveFile(jCasperArea,true);
    }

    /**
    * SaveAs Script button action performed.
    *
    * @param actionEvent ActionEvent
     */
    public void jButtonSaveAsScript_actionPerformed(ActionEvent e) {
        saveAsFile(jCasperArea,true);
    }



    /**
     * Load SOAP button action performed.
     *
     * @param actionEvent ActionEvent
     */

    public void jButtonLoadSOAP_actionPerformed(ActionEvent e) {
        if (!mdData.EnvirExists){
            JOptionPane.showMessageDialog(
                    this, "Protocol environment should be initialized first", "Error", JOptionPane.ERROR_MESSAGE);

        } else {
            // define a temp string to check whether the use has chose a new file.
            String szTemp = mdData.szSOAPFileName;
            mdData.szSOAPFileName = null;
            fileOpen(jSOAPArea, false);
            if (mdData.szSOAPFileName == null){ //the user aborted loading new SOAP
                mdData.szSOAPFileName = szTemp; //restore the previos SOAP file name
            } else {
                statusBar.setText("Checking whether the XML document is a valid SOAP message");
                phData = new phiData();
                phData.setSOAPFileName(mdData.szSOAPFileName);
                phData.setSOAPFileData(jSOAPArea.getText());
                phData.setAbstracted(mdData.Abstracted);
                phData.setFrameparent(this);
                phData.setCarriedNamesSet(mdData.CarriedNamesSet);
                phData.setParsingOptions(mdData.bValidating);
                phData.setSoapSchema(mdData.soapSchemaURI, mdData.soapSchemaFILE);
                phData.setWssSchema(mdData.wssSchemaURI, mdData.wssSchemaFILE);
                phData.setUtilitySchema(mdData.utilitySchemaURI, mdData.utilitySchemaFILE);
                phData.setXmlEncSchema(mdData.xmlEncURI, mdData.xmlEncFILE);
                phData.setXmlSigSchema(mdData.xmlSigURI, mdData.xmlSigFILE);
                phData.setFactory(mdData.factory);
                phData.setSOAPFileHandler(mdData.fhSOAP);

                parserClass.loadXML(phData);

                if ( phData.isXMLParserFatalError() || phData.isXMLParserNonFatalError() ){
                   //Display Initialization Log
                   SUDLogDisplay dlg = new SUDLogDisplay(this, "Parser Log", phData.getParserLog());
                   Dimension dlgSize = dlg.getPreferredSize();
                   Toolkit toolkit = Toolkit.getDefaultToolkit();
                   Dimension screenSize = toolkit.getScreenSize();

                   dlg.setLocation((screenSize.width - dlgSize.width) / 2,
                                   (screenSize.height - dlgSize.height) / 2);
                   dlg.setModal(true);
                   dlg.pack();
                   dlg.show();

                   if ( !phData.isXMLParserFatalError() ) {
                       int value = JOptionPane.showConfirmDialog(this,
                               "No fatal error were found, would you like to proceed",
                                                                 "Abort Load",
                                                                 JOptionPane.YES_NO_OPTION);

                       switch (value) {
                       case JOptionPane.YES_OPTION:

                           // yes, XML is loaded
                           mdData.SOAPLoaded = true;
                           break;
                       case JOptionPane.NO_OPTION:

                           // no
                           mdData.SOAPLoaded = false;
                           break;
                       default:

                           // cancel
                           mdData.SOAPLoaded = false;
                           break;
                       }
                   }
                } else
                    mdData.SOAPLoaded = true;

                if ( mdData.SOAPLoaded )
                    statusBar.setText("loaded " + mdData.szSOAPFileName);
                else
                    statusBar.setText("loading of " + mdData.szSOAPFileName + " was failed");
            }
        }
    }

    /**
     * ApplyPhi on SOAP message button action performed.
     *
     * @param actionEvent ActionEvent
     */
    public void jButtonApplyPhi_actionPerformed(ActionEvent e) {
        String szPhiResult;

        if ( !mdData.SOAPLoaded ){
            JOptionPane.showMessageDialog(
                    this, "SOAP message must be loaded before applying phi", "Error", JOptionPane.ERROR_MESSAGE);
        } else if ( phData != null && phData.isPhiAborted() ){
            JOptionPane.showMessageDialog(
                    this, "phi was aborted, try to reload SOAP message", "Error", JOptionPane.ERROR_MESSAGE);
        }else{
            mdData.bPhiDialogSuccess = false;
           //Display ApplyPhi doalog
           SUDApplyPhiDialog dlg = new SUDApplyPhiDialog(this, false, mdData, jCasperArea.getText());
           Dimension dlgSize = dlg.getPreferredSize();
           Toolkit toolkit = Toolkit.getDefaultToolkit();
           Dimension screenSize = toolkit.getScreenSize();

           dlg.setLocation((screenSize.width - dlgSize.width) / 2,
                           (screenSize.height - dlgSize.height) / 2);
           dlg.setModal(true);
           dlg.pack();
           dlg.show();

           if ( mdData.bPhiDialogSuccess ) {
               phData.phiClearContext();
               szPhiResult = phiClass.applyPhi(phData);
               if ( !phData.isPhiAborted() ) {
                  //Create the CasperData structure for following parsing
                  casperData csprData = new casperData();
                  csprData.setScript(jCasperArea.getText());
                  csprData.setTypes(mdData.Types);
                  csprData.setInitiator(mdData.Initator, mdData.szInitatorType);
                  csprData.setResponder(mdData.Responder, mdData.szInitatorType);
                  csprData.setSender(mdData.szSender, mdData.szSenderType);
                  csprData.setReceiver(mdData.szReceiver, mdData.szReceiverType);
                  csprData.setMessageAttr(mdData.szMsgNum, mdData.szAfterMsg);
                  csprData.setPsiDataSet(phData.getPsiDataSet());
                  String szNewScript = casperClass.updateScript(csprData, szPhiResult);

                  if ( !szNewScript.matches("") ) {
                      jCasperArea.setText(szNewScript);
                      statusBar.setText("Phi applied successufly to " + mdData.szSOAPFileName);
                  }
               }
           }
        }
    }




    // Handle the File|Open menu or button, invoking okToAbandon and openFile
  // as needed.
  void fileOpen(JTextArea jEdit, boolean IsCasperArea) {
    if (!okToAbandon(IsCasperArea)) {
      return;
    }
    // Use the OPEN version of the dialog, test return for Approve/Cancel
    if (JFileChooser.APPROVE_OPTION == jFileChooser1.showOpenDialog(this)) {
      // Call openFile to attempt to load the text from file into TextArea
      openFile(jEdit, IsCasperArea, jFileChooser1.getSelectedFile().getPath());
    }
    this.repaint();
  }

  // Open named file; read text from file into jTextArea1; report to statusBar.
  public void openFile(JTextArea jEdit, boolean IsCasperArea, String fileName)  {
    try
    {
      // Open a file of the given name.
      File file = new File(fileName);

      if ( !IsCasperArea )
          mdData.fhSOAP = file;

      // Get the size of the opened file.
      int size = (int)file.length();

      // Set to zero a counter for counting the number of
      // characters that have been read from the file.
      int chars_read = 0;


      // Create an input reader based on the file, so we can read its data.
      // FileReader handles international character encoding conversions.
      FileReader in = new FileReader(file);

      // Create a character array of the size of the file,
      // to use as a data buffer, into which we will read
      // the text data.
      char[] data = new char[size];

      // Read all available characters into the buffer.
      while(in.ready()) {
        // Increment the count for each character read,
        // and accumulate them in the data buffer.
        chars_read += in.read(data, chars_read, size - chars_read);
      }
      in.close();


      // Create a temporary string containing the data,
      // and set the string into the JTextArea.
      jEdit.setText(new String(data, 0, chars_read));

      // Cache the currently opened filename for use at save time...
      // ...and mark the edit session as being clean
      if (IsCasperArea) {
          mdData.szCasperFileName = fileName;
          mdData.dirtyCasper = false;
      } else {
          mdData.szSOAPFileName = fileName;
      }

      // Display the name of the opened directory+file in the statusBar.
      statusBar.setText("Opened "+fileName);
    }
    catch (IOException e)
    {
      statusBar.setText("Error opening "+fileName);
    }
  }

  // Check if file is dirty.
  // If so get user to make a "Save? yes/no/cancel" decision.
  boolean okToAbandon(boolean IsCasperArea) {

    if (!IsCasperArea){
        return true;
    }

    if (!mdData.dirtyCasper) {
      return true;
    }

    int value =  JOptionPane.showConfirmDialog(this, "Save Casper script changes?",
                                         "Text Edit", JOptionPane.YES_NO_CANCEL_OPTION) ;

    switch (value) {
       case JOptionPane.YES_OPTION:
         // yes, please save changes
         return saveFile(jCasperArea, IsCasperArea);
       case JOptionPane.NO_OPTION:
         // no, abandon edits
         // i.e. return true without saving
         return true;
       case JOptionPane.CANCEL_OPTION:
       default:
         // cancel
         return false;
    }
  }



    boolean saveFile(JTextArea jEdit, boolean IsCasperArea) {

     String tempfileName = null;
    // Handle the case where we don't have a file name yet.
    if (IsCasperArea) {
        if (mdData.szCasperFileName == null) {
            return saveAsFile(jEdit, IsCasperArea);
        }
    } else {
        if (mdData.szSOAPFileName == null) {
            return saveAsFile(jEdit, IsCasperArea);
        }
    }

    try
    {
      // Open a file of the current name.
      if (IsCasperArea) {
          tempfileName = mdData.szCasperFileName;
      } else {
          tempfileName = mdData.szSOAPFileName;
      }

      // Open a file of the current name.
      File file = new File(tempfileName);
      // Create an output writer that will write to that file.
      // FileWriter handles international characters encoding conversions.
      FileWriter out = new FileWriter(file);
      String text = jEdit.getText();
      out.write(text);
      out.close();

      if (IsCasperArea) {
          mdData.dirtyCasper = false;
      }
      // Display the name of the saved directory+file in the statusBar.
      statusBar.setText("Saved to " + tempfileName);
      return true;
    }
    catch (IOException e) {
    }
    return false;
  }

  // Save current file, asking user for new destination name.
  // Report to statuBar.
  boolean saveAsFile(JTextArea jEdit, boolean IsCasperArea) {
    this.repaint();
    // Use the SAVE version of the dialog, test return for Approve/Cancel
    if (JFileChooser.APPROVE_OPTION == jFileChooser1.showSaveDialog(this)) {
      // Set the current file name to the user's selection,
      // then do a regular saveFile
      if (IsCasperArea) {
          mdData.szCasperFileName = jFileChooser1.getSelectedFile().getPath();
      } else {
          mdData.szSOAPFileName = jFileChooser1.getSelectedFile().getPath();
      }
      //repaints menu after item is selected
      this.repaint();
      return saveFile(jEdit, IsCasperArea);
    }
    else {
      this.repaint();
      return false;
    }
  }

  private void initialize() {

     initTask = new SUDClass_EnvInit(mdData);

     initTask.InitEnvir(mdData);

     //Display Initialization Log
     SUDLogDisplay dlg = new SUDLogDisplay(this, "Initialization Log", initTask.getLog());
     Dimension dlgSize = dlg.getPreferredSize();
     Toolkit toolkit = Toolkit.getDefaultToolkit();
     Dimension screenSize = toolkit.getScreenSize();

     dlg.setLocation((screenSize.width - dlgSize.width) / 2,
                     (screenSize.height - dlgSize.height) / 2);
     dlg.setModal(true);
     dlg.pack();
     dlg.show();
  }

  public void setConfiguration() {
      phData = new phiData();

       phData.setParsingOptions(mdData.bValidating);
       phData.setSoapSchema(mdData.soapSchemaURI, mdData.soapSchemaFILE);
       phData.setWssSchema(mdData.wssSchemaURI, mdData.wssSchemaFILE);
       phData.setUtilitySchema(mdData.utilitySchemaURI, mdData.utilitySchemaFILE);
       phData.setXmlEncSchema(mdData.xmlEncURI, mdData.xmlEncFILE);
       phData.setXmlSigSchema(mdData.xmlSigURI, mdData.xmlSigFILE);

       parserClass.setParserConfiguration(phData);

       mdData.factory = phData.getFactory();

  }

}


class SUDFrame_jButtonApplyPhi_actionAdapter implements ActionListener {
    private SUDFrame adaptee;
    SUDFrame_jButtonApplyPhi_actionAdapter(SUDFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonApplyPhi_actionPerformed(e);
    }
}


class SUDFrame_jButtonSaveAsScript_actionAdapter implements ActionListener {
    private SUDFrame adaptee;
    SUDFrame_jButtonSaveAsScript_actionAdapter(SUDFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonSaveAsScript_actionPerformed(e);
    }
}


class SUDFrame_jButtonLoadSOAP_actionAdapter implements ActionListener {
    private SUDFrame adaptee;
    SUDFrame_jButtonLoadSOAP_actionAdapter(SUDFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonLoadSOAP_actionPerformed(e);
    }
}


class SUDFrame_jButtonSaveScript_actionAdapter implements ActionListener {
    private SUDFrame adaptee;
    SUDFrame_jButtonSaveScript_actionAdapter(SUDFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonSaveScript_actionPerformed(e);
    }
}


class SUDFrame_jMenuFileExit_ActionAdapter implements ActionListener {
    SUDFrame adaptee;

    SUDFrame_jMenuFileExit_ActionAdapter(SUDFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent actionEvent) {
        adaptee.jMenuFileExit_actionPerformed(actionEvent);
    }
}


class SUDFrame_jMenuFileNew_ActionAdapter implements ActionListener {
    SUDFrame adaptee;

    SUDFrame_jMenuFileNew_ActionAdapter(SUDFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent actionEvent) {
        adaptee.jMenuFileNew_actionPerformed(actionEvent);
    }
}

class SUDFrame_jMenuFileInitialize_ActionAdapter implements ActionListener {
    SUDFrame adaptee;

    SUDFrame_jMenuFileInitialize_ActionAdapter(SUDFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent actionEvent) {
        adaptee.jMenuFileInitialize_actionPerformed(actionEvent);
    }
}


class SUDFrame_jMenuFontChooser_ActionAdapter implements ActionListener {
    SUDFrame adaptee;

    SUDFrame_jMenuFontChooser_ActionAdapter(SUDFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent actionEvent) {
        final SUDFrame_FontChooser chooser = new SUDFrame_FontChooser(adaptee);

        // Pop up the dialog
        chooser.setSelectedFont(adaptee.jSOAPArea.getFont());

        // Pop up the dialog
        Dimension dlgSize = chooser.getPreferredSize();
        Toolkit toolkit = Toolkit.getDefaultToolkit();
        Dimension screenSize = toolkit.getScreenSize();

        chooser.setLocation((screenSize.width - 620) / 2,
                        (screenSize.height - dlgSize.height) / 2);

        chooser.show();
        Font font = chooser.getSelectedFont();

        if (font != null){
            adaptee.jCasperArea.setFont(font);
            adaptee.jSOAPArea.setFont(font);
        }

    }
}


class SUDFrame_jMenuEditColor_ActionAdapter implements ActionListener {
    SUDFrame adaptee;

    SUDFrame_jMenuEditColor_ActionAdapter(SUDFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent actionEvent) {

        Color color = JColorChooser.showDialog(adaptee,"Foreground Color", adaptee.jCasperArea.getForeground());

        if ( actionEvent.getSource() == adaptee.jMenuEditForeGroundColor ) {
            adaptee.jCasperArea.setForeground(color);
            adaptee.jSOAPArea.setForeground(color);
        } else if ( actionEvent.getSource() == adaptee.jMenuEditBackGroundColor ) {
            adaptee.jCasperArea.setBackground(color);
            adaptee.jSOAPArea.setBackground(color);
        }

    }
}

class SUDFrame_jMenuConfiguration_ActionAdapter implements ActionListener {
    SUDFrame adaptee;

    SUDFrame_jMenuConfiguration_ActionAdapter(SUDFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent actionEvent) {


        if (actionEvent.getSource() == adaptee.jMenuConfigurationParser) {
            SUDFrame_ParserConfigureBox dlg = new SUDFrame_ParserConfigureBox(adaptee, adaptee.mdData);
            Dimension dlgSize = dlg.getPreferredSize();
            Toolkit toolkit = Toolkit.getDefaultToolkit();
            Dimension screenSize = toolkit.getScreenSize();

            dlg.setLocation((screenSize.width - dlgSize.width) / 2,
                            (screenSize.height - dlgSize.height) / 2);
            dlg.setModal(true);
            dlg.pack();
            adaptee.mdData.parserConfigurationLoaded = false;
            dlg.show();
            if ( adaptee.mdData.parserConfigurationLoaded == true )
                adaptee.setConfiguration();
        }
    }

}


class SUDFrame_jMenuLogs_ActionAdapter implements ActionListener {
    SUDFrame adaptee;

    SUDFrame_jMenuLogs_ActionAdapter(SUDFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent actionEvent) {


        if ( actionEvent.getSource() == adaptee.jMenuLogsInitialization ) {
            if ( adaptee.initTask != null ) {
                SUDLogDisplay dlg = new SUDLogDisplay(adaptee, "Initialization Log", adaptee.initTask.getLog());
                Dimension dlgSize = dlg.getPreferredSize();
                Toolkit toolkit = Toolkit.getDefaultToolkit();
                Dimension screenSize = toolkit.getScreenSize();

                dlg.setLocation((screenSize.width - dlgSize.width) / 2,
                                (screenSize.height - dlgSize.height) / 2);
                dlg.setModal(true);
                dlg.pack();
                dlg.show();

            } else
                JOptionPane.showMessageDialog(null,
                                              "No initialization log is available" ,
                                              "Information",
                                              JOptionPane.INFORMATION_MESSAGE);

        } else if ( actionEvent.getSource() == adaptee.jMenuLogsParser ) {
            if (adaptee.phData != null && !adaptee.phData.getParserLog().matches("") ) {
              //Display Parser Log
              SUDLogDisplay dlg = new SUDLogDisplay(adaptee, "Parser Log", adaptee.phData.getParserLog());
              Dimension dlgSize = dlg.getPreferredSize();
              Toolkit toolkit = Toolkit.getDefaultToolkit();
              Dimension screenSize = toolkit.getScreenSize();

              dlg.setLocation((screenSize.width - dlgSize.width) / 2,
                              (screenSize.height - dlgSize.height) / 2);
              dlg.setModal(true);
              dlg.pack();
              dlg.show();

          } else
              JOptionPane.showMessageDialog(null,
                                            "No Parser log is available" ,
                                            "Information",
                                            JOptionPane.INFORMATION_MESSAGE);

        }

    }
}

class SUDFrame_jMenuHelpAbout_ActionAdapter implements ActionListener {
    SUDFrame adaptee;

    SUDFrame_jMenuHelpAbout_ActionAdapter(SUDFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent actionEvent) {
        adaptee.jMenuHelpAbout_actionPerformed(actionEvent);
    }
}
