package sud;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;


/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 *  This dialog is called when the new protocol option is chosen
 *  it set in the mdData structure the following fields
 *
 *  Abstracted
 *  Initiator
 *  Responder
 *
 * @Eldar Kleiner
 * @version 1.0
 */

public class SUDFrame_NewProtocol extends JDialog implements ActionListener {
    SUDData localData;
    JPanel panel1 = new JPanel();
    JButton button1 = new JButton();
    ImageIcon image1 = new ImageIcon();
    String szErrorMessage = "";
    JLabel jLabelError = new JLabel();
    JLabel jLabel1 = new JLabel();
    JRadioButton jRadioButtonAbstracted = new JRadioButton();
    JRadioButton jRadioButtonBinary = new JRadioButton();
    JLabel jLabel2 = new JLabel();
    JLabel jLabelInitiator = new JLabel();
    JLabel jLabelInitiatorType = new JLabel();
    JTextField jTextFieldInitiator = new JTextField();
    JLabel jLabelResponder = new JLabel();
    JTextField jTextFieldResponder = new JTextField();
    JLabel jLableFieldResponderType = new JLabel();
    GridBagLayout gridBagLayout1 = new GridBagLayout();
    JButton jCancel = new JButton();
    JComboBox jComboBoxInitiator;
    JComboBox jComboBoxResponder;


    public SUDFrame_NewProtocol(Frame parent, SUDData mdData) {
        super(parent);
        try {
            setDefaultCloseOperation(DISPOSE_ON_CLOSE);
            jbInit(mdData);
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }

    public SUDFrame_NewProtocol() {
//
    }

    /**
     * Component initialization.
     *
     * @throws java.lang.Exception
     */
    private void jbInit(SUDData mdData) throws Exception {
        localData = mdData;
        image1 = new ImageIcon(sud.SUDFrame.class.getResource("about.png"));
        jComboBoxInitiator = new JComboBox(localData.Types);
        jComboBoxResponder = new JComboBox(localData.Types);
        setTitle("New protocol");
        panel1.setLayout(gridBagLayout1);
        jComboBoxInitiator.setSelectedIndex(0);
        jComboBoxResponder.setSelectedIndex(0);
        button1.setText("OK");
        button1.addActionListener(this);
        jLabelError.setFont(new java.awt.Font("SansSerif", Font.BOLD, 16));
        jLabelError.setForeground(Color.red);
        jLabelError.setText("");
        jLabel1.setFont(new java.awt.Font("SansSerif", Font.PLAIN, 14));
        jLabel1.setText("How do binary values apper in the protocol");
        jRadioButtonAbstracted.setFont(new java.awt.Font("SansSerif", Font.PLAIN, 14));
        jRadioButtonAbstracted.setText("Abstracted");
        jRadioButtonAbstracted.addActionListener(this);
        jRadioButtonBinary.setFont(new java.awt.Font("SansSerif", Font.PLAIN, 14));
        jRadioButtonBinary.setText("As binary values");
        jRadioButtonBinary.addActionListener(this);
        jLabel2.setFont(new java.awt.Font("SansSerif", Font.PLAIN, 14));
        jLabel2.setText("Please choose variables to represent agents");
        jLabelInitiator.setFont(new java.awt.Font("SansSerif", Font.PLAIN, 14));
        jLabelInitiator.setText("Initiator");
        jLabelInitiatorType.setFont(new java.awt.Font("SansSerif", Font.PLAIN, 14));
        jLabelInitiatorType.setText("Of type:");
        jTextFieldInitiator.setText("A");
        jLabelResponder.setFont(new java.awt.Font("SansSerif", Font.PLAIN, 14));
        jLabelResponder.setText("Responder");
        jLableFieldResponderType.setFont(new java.awt.Font("SansSerif", Font.PLAIN, 14));
        jLableFieldResponderType.setText("Of type:");
        jTextFieldResponder.setText("B");
        jCancel.setText("Cancel");
        jCancel.addActionListener(this);
        getContentPane().add(panel1, null);
        panel1.add(jLabelError, new GridBagConstraints(1, 6, 4, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(7, 22, 16, 101), 187, 29));
        panel1.add(jLabel1, new GridBagConstraints(0, 0, 5, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(11, 58, 0, 57), 16, 18));
        panel1.add(jRadioButtonBinary,
                   new GridBagConstraints(2, 1, 3, 1, 0.0, 0.0
                                          , GridBagConstraints.CENTER,
                                          GridBagConstraints.NONE,
                                          new Insets(0, 93, 0, 11), 44, 21));
        panel1.add(jRadioButtonAbstracted,
                   new GridBagConstraints(0, 1, 4, 1, 0.0, 0.0
                                          , GridBagConstraints.CENTER,
                                          GridBagConstraints.NONE,
                                          new Insets(0, 23, 0, 146), 9, 20));
        panel1.add(jLabel2, new GridBagConstraints(0, 2, 5, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(9, 45, 0, 66), 7, 14));
        panel1.add(jTextFieldInitiator,
                   new GridBagConstraints(1, 3, 1, 1, 1.0, 0.0
                                          , GridBagConstraints.WEST,
                                          GridBagConstraints.HORIZONTAL,
                                          new Insets(26, 0, 0, 0), 15, 7));

        panel1.add(jComboBoxInitiator,
                   new GridBagConstraints(1, 4, 1, 1, 1.0, 0.0
                                          , GridBagConstraints.WEST,
                                          GridBagConstraints.HORIZONTAL,
                                          new Insets(0, 0, 0, 0), 15, 7));


        panel1.add(jLabelInitiator, new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(28, 23, 0, 0), 21, 6));
        panel1.add(jLabelInitiatorType, new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(0, 23, 0, 0), 21, 6));

        panel1.add(jTextFieldResponder,
                   new GridBagConstraints(4, 3, 1, 1, 1.0, 0.0
                                          , GridBagConstraints.WEST,
                                          GridBagConstraints.HORIZONTAL,
                                          new Insets(29, 14, 0, 74), 20, 5));

        panel1.add(jComboBoxResponder,
                   new GridBagConstraints(4, 4, 1, 1, 1.0, 0.0
                                          , GridBagConstraints.WEST,
                                          GridBagConstraints.HORIZONTAL,
                                          new Insets(0, 14, 0, 74), 20, 5));


        panel1.add(jLabelResponder, new GridBagConstraints(2, 3, 2, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(31, 78, 0, 0), 3, 6));
        panel1.add(jLableFieldResponderType, new GridBagConstraints(2, 4, 2, 1, 0.0, 0.0
               , GridBagConstraints.WEST, GridBagConstraints.NONE,
               new Insets(0, 78, 0, 0), 3, 6));

        panel1.add(button1, new GridBagConstraints(2, 5, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(30, 3, 0, 0), 10, 0));
        panel1.add(jCancel, new GridBagConstraints(3, 5, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE,
                new Insets(30, 3, 0, 0), 10, 0));
        setResizable(true);
    }

    /**
     * Close the dialog on a button event if all filds are full.
     *
     * on a radio button event turn off the other button.
     *
     * @param actionEvent ActionEvent
     */
    public void actionPerformed(ActionEvent actionEvent) {
        if (actionEvent.getSource() == button1) {
            if (jRadioButtonAbstracted.isSelected() || jRadioButtonBinary.isSelected()){
                if (!jTextFieldInitiator.getText().equals("") && !jTextFieldResponder.getText().equals("")){
                    localData.Initator = jTextFieldInitiator.getText();
                    localData.Responder = jTextFieldResponder.getText();
                    localData.szInitatorType = (String)jComboBoxInitiator.getSelectedItem();
                    localData.szResponderType = (String)jComboBoxResponder.getSelectedItem();
                    dispose();
                }
            }
            jLabelError.setText("All fields must be filled");
        } else if ( actionEvent.getSource() == jCancel) {
           localData.bLoadCancelled = true;
           dispose();
        } else if (actionEvent.getSource() == jRadioButtonAbstracted && jRadioButtonAbstracted.isSelected()) {
            jRadioButtonBinary.setSelected(false);
            localData.Abstracted = true;
        } else if (actionEvent.getSource() == jRadioButtonBinary && jRadioButtonBinary.isSelected()) {
            jRadioButtonAbstracted.setSelected(false);
            localData.Abstracted = false;
        }
    }
}

