package sud;

import java.awt.BorderLayout;
import java.awt.Frame;

import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JLabel;
import java.awt.*;
import javax.swing.JTextArea;
import javax.swing.JButton;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JScrollPane;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class SUDLogDisplay extends JDialog {
    JPanel panel1 = new JPanel();
    JLabel jTitle = new JLabel();
    JTextArea jTextArea1 = new JTextArea(13, 70);
    JButton jOk = new JButton();
    GridBagLayout gridBagLayout1 = new GridBagLayout();

    public SUDLogDisplay(Frame owner, String title, String szTitle, String szLog) {
        super(owner, title, true);
        try {
            setDefaultCloseOperation(DISPOSE_ON_CLOSE);
            jbInit(szTitle, szLog);
            pack();
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }

    public SUDLogDisplay(Frame owner, String szTitle, String szLog) {
        this(owner, "Log", szTitle, szLog);
    }

    private void jbInit(String szTitle, String szLog) throws Exception {
        panel1.setLayout(gridBagLayout1);
        jTitle.setFont(new java.awt.Font("SansSerif", Font.PLAIN, 16));
        jTitle.setForeground(SystemColor.desktop);
        jTitle.setText(szTitle);
        jTextArea1.setEditable(false);
        JScrollPane scrollPane1Text = new JScrollPane(jTextArea1);
        jTextArea1.setText(szLog);
        jOk.setText("OK");
        jOk.addActionListener(new SUDLogDisplay_jOk_actionAdapter(this));
        getContentPane().add(panel1);
        panel1.add(jTitle, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                                                  , GridBagConstraints.WEST,
                                                  GridBagConstraints.NONE,
                                                  new Insets(13, 16, 0, 0), 97,
                                                  10));
        panel1.add(scrollPane1Text, new GridBagConstraints(0, 1, 2, 1, 1.0, 1.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH,
                new Insets(19, 16, 0, 16), 295, 166));
        panel1.add(jOk, new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0
                                               , GridBagConstraints.CENTER,
                                               GridBagConstraints.NONE,
                                               new Insets(16, 0, 12, 158), 35,
                                               3));
    }

    public void jOk_actionPerformed(ActionEvent e) {
        dispose();
    }
}


class SUDLogDisplay_jOk_actionAdapter implements ActionListener {
    private SUDLogDisplay adaptee;
    SUDLogDisplay_jOk_actionAdapter(SUDLogDisplay adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jOk_actionPerformed(e);
    }
}
